@cT datastream 1
@4FONT
  1
 17 zsymbol
@5FONT
$syntaxlevel 2
$window	635,435

* One-, two-, and three-body gravitational motion; August 1997
* Bruce Sherwood
* Center for Innovation in Learning and Dept. of Physics
* Carnegie Mellon University

* Version 2.0 adds energy display, and option to set masses
* Version 2.1 sets directory to the "setups" directory containing setu@
p files
* Version 3.0 handles inelastic  collisions rather than stopping plott@
ing;
*    also corrects some bugs in returning from menu units

* @1ff   1To see one or more hidden units, select units with mouse, th@
en
*   choose "Show Units" on Edit menu. Or choose "Show All Units".@
@1ff8000

define	group,masses:	$$ define a group of variables to be shared among@
 several units
	integer: Type	$$ type of situation
* Type = 0 means that no situation has been chosen yet (user is lookin@
g at title page)
* Type = 1 means two objects, one fixed and one moving (unit TwoWithOn@
eMoving)
* Type = 2 means two objects, both moving around a fixed center of mas@
s (unit TwoMovingAboutCM)
* Type = 3 means two objects, both moving (drag mouse to set initial c@
onditions for both) (unit TwoMoving)
* Type = 4 means three objects, two fixed and one moving (unit TwoFixe@
dAndOneMoving)
* Type = 5 means three objects, all three moving (unit ThreeMoving)

	float: G=1		$$ choose units so that the gravitational constant is 1
	integer: NOBJS=3	$$ number of masses
	integer: Halt	$$ TRUE if should stop plotting
	float: DT		$$ time step @1fg  17D@1fg8000t
	integer: DTcount	$$ number of time intervals since last dot was plott@
ed
	integer: MaxDTcount	$$ number of time intervals before plotting a dot
	integer: RunFromFile	$$ if TRUE, use existing data or data from file @
rather than entered by user
	integer: AtPause	$$ if TRUE, currently waiting at initial -pause- in @
unit GetInitialConditions
	integer: OFFSCREEN=1000  $$ initial position before user has specifie@
d the position

* A one-dimensional "array" defined as "Data(5)" is a set of numbers r@
eferred to as Data(1), Data(2), ... Data(5).
* A two-dimensional "array" defined as "Obj(3,7)" is a set of numbers @
referred to as Obj(1,1), Obj(1,2), ...
*      Obj(1,8), Obj(2,1), Obj(2,2), ... Obj(2,8), Obj(3,1), Obj(3,2),@
 ... Obj(3,8).
* Such a two-dimensional array is used in this program to keep track o@
f x, y, v@1fsffec@1ff  20x@1fs8000@1ff8000, v@1fsffec@1ff  20y@1fs8000@
@1ff8000,
*     mass, radius, color, and fixed-location nature of the object, fo@
r each of three masses.
* To make the body of the program easier to read and modify, symbolic @
names are given to the locations in
*     the array. For example, "R" is defined to mean "6" so that Obj(3@
,R) means Obj(3,6), the radius of object #3.

* Indices in the following "Obj" array refer to x, y, v@1fsffec@
@1ff  20x@1fs8000@1ff8000, v@1fsffec@1ff  20y@1fs8000@1ff8000, mass, r@
adius, color, fixed location if TRUE:
	integer: X=1, Y=2, VX=3, VY=4, M=5, R=6, COLOR=7, FIXED=8
* Define a two-dimensional array that contains 3*8 = 24 elements:
	float: Obj(NOBJS,FIXED)  $$ completely describe an object; doesn't mo@
ve if Obj(N,FIXED) is TRUE
	float: Initial(NOBJS,FIXED)	$$ save initial conditions for all object@
s (to show on a second attempt)
	float: Lastxy(NOBJS,FIXED)	$$ save previous values for each object
	float: MTOR=0.1	$$ convert mass to radius by MTOR*Obj(n,M)^(1/3)
	
	group,energy:
	f: PE, KE, TE	$$ previous values of potential, kinetic, and total ene@
rgy
	i: LABEL=1, SETPE=2, SETKE=3, SHOW=4  $$ ShowEnergy methods
	f: EMAX=5		$$ maximum energy to display
	i: ShowEnergy	$$ if TRUE, display energy bargraphs

	
********************
unit	Setup		$$ set up basic parameters
@1pl4001	merge,masses:	$$ "global" variables common to several units
	merge,energy:
font	zsans,15		$$ sans-serif font for execution display
setdir	"./setups"		$$ point to built-in situation setup files

calc	DT := 0.01		$$ specify time step size
	MaxDTcount := 1	$$ number of time intervals before plotting a dot
	Type := 0		$$ no type of situation chosen yet
	RunFromFile := FALSE	$$ initial conditions not yet chosen
	AtPause := FALSE	$$ signal that user is not at the -pause- command in@
 unit GetInitialConditions
	ShowEnergy := FALSE	$$ don't show energy bargraphs
	Obj(1,M) := 2	$$ preset masses
	Obj(2,M) := 1
	Obj(3,M) := 0.1

* Create pull-down menu for file operations:
menu	File; Save this situation in a file: SaveSituation
menu	File; Get situation from a file: GetSituation
menu	File; ----------: DummyMenu  $$ make a dividing line on the menu @
card
menu	File; Page setup: PrintScreenSetup
menu	File; Print screen: PrintScreen
menu	File; ---------: DummyMenu  $$ make a dividing line on the menu c@
ard
menu	File; Quit: Quit

menu	Option		$$ delete standard cT "Option" menu

* Create pull-down menu for choosing a situation:
menu	Choose Situation; One object fixed and one moving,1: SetSituation@
(1)
menu	Choose Situation; Two objects moving about center of mass,2: SetS@
ituation(2)
menu	Choose Situation; Two objects moving,3: SetSituation(3)
menu	Choose Situation; Two objects fixed and one moving,4: SetSituatio@
n(4)
menu	Choose Situation; Three objects moving,5: SetSituation(5)
menu	Choose Situation; ----------,10: DummyMenu  $$ make a dividing li@
ne on the menu card
menu	Choose Situation; Repeat previous orbit,11: Repeat
menu	Choose Situation; ---------,20: DummyMenu  $$ make a dividing lin@
e on the menu card
menu	Choose Situation; Set time interval,21: jSetTimeInterval
menu	Choose Situation; Set masses of objects,22: jSetMasses
menu	Choose Situation; Show energy bar graphs,23: ChooseEnergyGraphs
menu	Choose Situation; --------,30: DummyMenu  $$ make a dividing line@
 on the menu card
menu	Choose Situation; Title page,31: PreTitlePage

do	PreTitlePage	$$ unit PreTitlePage will jump to the title page
********************
@1pl8000unit	PreTitlePage	$$ menu choice of "Title page" brings us her@
e
@1pl4001jump	TitlePage
********************
@1pl8000unit	TitlePage		$$ display title and credits
@1pl4001	merge,masses:	$$ "global" variables common to several units
color	zblack		$$ make sure we're in standard writing color and mode
mode	write
text	0,(zymax-16*10)/2;zxmax,zymax  $$ zxmax, zymax gives the size of @
the window
@1fs  14@1ff   1@1pl4003@1cl   2Orbits@1fs8000@1ff8000@1cl   0
@1cl   2of two or three gravitating objects@1cl   0
@1cl8000
@1fsffecBruce Sherwood, Center for Innovation in Learning
and Dept. of Physics, Carnegie Mellon University, 1997
@1fs8000@1cl   0
@1fsffecversion 3.0@1cl8000 @1fs8000

@1fsffec@1cl   0
@1fs8000@1cl   4Choose a situation from the pull-down menu@1cl8000
@1pl4001\
text	10,zymax-70; zxmax-85,zymax
@1fsffec@1pl4007Permission is granted to use and distribute this progr@
am for any purpose, and you are welcome to modify it. It is written in@
 the cT programming language (http://cil.andrew.cmu.edu/ct).@1fsffd8 @
@1fsffecThis work was supported, in part, by the National Science Foun@
dation.  Opinions expressed are those of the author, and not necessari@
ly those of the Foundation.@1fs8000
@1pl4001\
at	zxmax-75,zymax-80
plot	@
@4STXT
134
-1
680
71 0 0 -68 
71 68 0 0 
71 68 
0000000000000000000000000000000000000000000000002000000000000000
0000200000000000000000003000000000000000000070000000000000003000
70004000000000003000f800e000000000001803fe00c000000000001e7ffff7
c000000000001fe0f83fc000000000001f80700fc000000000001f80f00fc000
000000003f80f80fe0000000000037c0d81f60000000000043e0883e10000000
000083718c66080000000001031904c40608000001c7010d0584071c000000fe
0107ff0c03f80000007e019c01cc07f00000003f80b3fe681fe00000003ff8cf
ff99ffe00000001fffbfffcfdfc000000031837ffff40c6000000030c2fffffa
18600000002066ffffcb30200000002025ffff856020000000601fffff1dc020
000000600bffff1e8030000000e07a010006e030000001f7de01000efc380000
1fff1e393f1e87fc00001ffe1e39031ec3ffc00003ff1e39811e87ffc00000e3
de39f81e9f7c000000c03a38f81ef030000000400a38011e8030000000601a78
031dc0300000006025fffffd60200000002065fffffb302000000020c2fffffa
182000000031837ffff41c600000003f8fbfffee0fc00000003ffcdfff9bffe0
0000003fc0e7ff783fe00000007f011c71cc07e0000000fe0107ff0c03f80000
01fe010dfd0c03fc0000018303190cc40608000000018331886c0c0000000000
c3e1883e18000000000067c0d81f2000000000003f80f00fe000000000001f80
f00fc000000000001f80f00f8000000000001fc0f03f8000000000001ffffbff
8000000000001c07ff01c000000000001801f800c000000000003000f0004000
0000000000006000000000000000000060000000000000000000600000000000
0000000060000000000000000000000000000000000000000000000000000000
0000000000000000
@5STXT

********************
@1pl8000unit	Main		$$ main unit to which we keep returning
@1pl4001	merge,masses:	$$ "global" variables common to several units
	merge,energy:
	integer: nobj	$$ "local" variables nobj, x0, y0, x, y usable only wit@
hin unit Main
color	zblack		$$ make sure we're in standard writing color and mode
mode	write
thick	2		$$ make dots and vectors double-thick

do	OrbitCoordinates	$$ coordinate system for plotting the interacting @
objects

at	1,1
write	Drag to set initial conditions

do	ShowObjects(FALSE)	$$ show all objects, not in "exclusive or" mode

* Display initial velocities in a pale green, choosing colors using th@
e "hsv" way
*   of specifying hue, saturation, and value (brightness). A hue of 18@
0 degrees is green, a
*   saturation of 60 percent means that 40% white has been mixed with @
the green, and a
*   value of 75 percent means a brightness 75% of full brightness:
color	hsv,180,60,75
loop	nobj := 1, NOBJS
	reloop	Obj(nobj,X) = OFFSCREEN
	gvector	Obj(nobj,X),Obj(nobj,Y); Obj(nobj,X)+Obj(nobj,VX),Obj(nobj,Y)@
+Obj(nobj,VY); 10
endloop
block	Obj,Initial		$$ save initial conditions

* The following -case- command chooses different statements depending @
on the value of Type:
case	Type
1
	do	GetInitialConditions(2)   $$ get initial conditions for object 2
2
	do	GetInitialConditions(2)   $$ get initial conditions for object 2
3
	do	GetInitialConditions(1)   $$ get initial conditions for object 1
	do	GetInitialConditions(2)   $$ get initial conditions for object 2
4
	do	GetInitialConditions(3)   $$ get initial conditions for object 3
5
	do	GetInitialConditions(3)   $$ get initial conditions for object 3
endcase
calc	AtPause := FALSE	$$ signal that user is no longer waiting at -pau@
se- in unit GetInitialConditions
	RunFromFile := FALSE	 $$ next time, get initial conditions from user
block	Obj,Initial		$$ save (possiby modified) initial conditions

erase			$$ erase the entire screen
do	ShowObjects(TRUE)	$$ show moving objects in "exclusive or" mode
mode	write
color	zblack
at	1,1
write	Click to stop plotting
if	ShowEnergy	$$ display initial energies
	do	ShowEnergy(0,0,SETPE)
	do	ShowEnergy(0,0,SETKE)
	do	ShowEnergy(0,0,LABEL)
endif

@1ff   1@1cl   2do	Plot		$$ calculate and plot the motion of the objec@
ts@1ff8000@1cl8000

block	Initial,Obj		$$ restore initial conditions

color	zblack
erase	0,0;165,20	$$ erase "Click to stop plotting"
at	zxmax/2-50,1
write	Click to start over
pause	keys=touch		$$ wait for mouse click
jump	Main
********************
@1ff   1@1pl8000@1cl   2unit	Plot		$$ calculate and plot the motion@
@1ff8000@1cl8000
@1pl4001	merge,masses:
	integer: nobj
	float: time
calc	time := 0
	Halt := FALSE
	DTcount := 1	$$ count number of intervals before plotting a dot along@
 the trail
	
loop	nobj := 1, NOBJS	$$ take initial half step to improve accuracy
	calc	Obj(nobj,X) := Obj(nobj,X)+Obj(nobj,VX)*DT/2
		Obj(nobj,Y) := Obj(nobj,Y)+Obj(nobj,VY)*DT/2
endloop
loop	~Halt	$$ keep plotting as long as not told to halt (due to collis@
ion)
	getkey			$$ check to see whether an input has been made
	outunit	zkey = zk(touch)	$$ get out of unit if the user has made an i@
nput
	
	@1ff   1@1cl   2do	Step	$$ take one step in the numerical integration@
@1ff8000@1cl8000
	
	loop	nobj := 1, NOBJS		$$ show the new positions of the objects
		reloop	Obj(nobj,FIXED)	$$ don't bother if this object doesn't move

* In xor or "exclusive or" mode of writing, writing the same thing twi@
ce leaves the screen unchanged,
*    because a pixel's color is flipped, first one way and then anothe@
r. This leaves the background intact.
		if	MaxDTcount > 0	$$ we're plotting dots; plot disks in mode xor
			mode	xor	$$ "exclusive or" mode of writing
		else
			mode	erase	$$ plotting disks in color; erase the disk
		endif
		gatnm	Lastxy(nobj,X), Lastxy(nobj,Y)
		gdisk	Lastxy(nobj,R)	$$ this removes the previous disk
		mode	write		$$ restore normal writing mode
		
		if	Obj(nobj,M) > 0 & DTcount >= MaxDTcount & MaxDTcount > 0
			color	Obj(nobj,COLOR)
			gdot	Obj(nobj,X), Obj(nobj,Y)  $$ leave a trail of dots
		endif
		
		if	MaxDTcount > 0	$$ we're plotting dots; plot disks in mode xor
			mode	xor	$$ "exclusive or" mode of writing
		else
			color	Obj(nobj,COLOR)	$$ plotting disks in color
		endif
		if	Obj(nobj,M) > 0
			gatnm	Lastxy(nobj,X) := Obj(nobj,X),Lastxy(nobj,Y) := Obj(nobj,Y)
			gdisk	Lastxy(nobj,R) := Obj(nobj,R)	$$ display disk in new position
		else
			calc	Lastxy(nobj,X) := 1E12
				Lastxy(nobj,Y) := 1E12
		endif
	endloop
	calc	time := time+DT	$$ if interested in elapsed time
	if	DTcount >= MaxDTcount
		calc	DTcount := 1
	else
		calc	DTcount := DTcount+1	$$ increment interval count
	endif
endloop
********************
@1ff   1@1pl8000@1cl   2unit	Step		$$ step the velocity and position f@
or all objects@1ff8000@1cl8000
@1pl4001	merge,masses:
	merge,energy:
	float: xr, yr	$$ relative x,y of attracting object
	float: temp		$$ element in determing dv@1fsffec@1ff  20x@1fs8000@
@1ff8000 and dv@1fsffec@1ff  20y@1fs8000@1ff8000
	float: rr		$$ distance between centers of  objects
	float: pe, ke	$$ gravitational potential energy; kinetic energy
	integer: n1, n2	$$ loop indices
	integer: nmasses	$$ NOBJS, or 2 if Type <= 3
	integer: collision	$$ TRUE if collision detected
if	Type <= 3
	calc	nmasses := 2
else
	calc	nmasses := NOBJS
endif
calc	pe := ke := 0
	collision := FALSE
loop	n1 := 1, nmasses	$$ determine dv for object "n1", step the veloci@
ty
	reloop	Obj(n1,FIXED) | Obj(n1,M) = 0	$$ nothing to do if object n1 is@
  fixed in position (or absent)
	loop	n2 := 1, nmasses		$$ add up effects of all other masses
		reloop	n2 = n1 | Obj(n2,M) = 0	$$ an object doesn't act on itself (o@
r if absent)
		calc	xr := Obj(n2,X)-Obj(n1,X)	$$ relative location of other object
			yr := Obj(n2,Y)-Obj(n1,Y)
			rr := sqrt{xr^2+yr^2}	$$ center-to-center distance
			temp := G*Obj(n2,M)*DT/rr^3	$$ elements common to x and y
			Obj(n1,VX) := Obj(n1,VX)+temp*xr  $$ dv@1fsffec@1ff  20x@1fs8000@
@1ff8000 proportional to x/r@1fsffec@1ff  403@1fs8000@1ff8000
			Obj(n1,VY) := Obj(n1,VY)+temp*yr  $$ dv@1fsffec@1ff  20y@1fs8000@
@1ff8000 proportional to y/r@1fsffec@1ff  403@1fs8000@1ff8000
			pe := pe-G*Obj(n1,M)*Obj(n2,M)/rr
		if	rr <= Obj(n1,R)+Obj(n2,R) & Obj(n2,M) > 0   $$ detected a collisi@
on
			calc	collision := TRUE
			* Cannot adjust masses here; must finish these loops to get correct@
 momenta
		endif
	endloop
	calc	ke := ke+0.5*Obj(n1,M)*[Obj(n1,VX)^2+Obj(n1,VY)^2]
endloop
if	~(Type = 1 | Type = 4)   $$ if only one mass moving
	calc	pe := pe/2	$$ take care of double-counting in above loop 
endif

if	collision	$$ there was a collision; adjust masses and speeds for in@
elastic collision
	loop	n1 := 1, nmasses
		loop	n2 := 1, nmasses
			reloop	n2 = n1
			if	Obj(n2,FIXED)	$$ quit if hit a fixed object
				calc	Halt := TRUE
				outunit
			endif
			calc	xr := Obj(n2,X)-Obj(n1,X)	$$ relative location of other object
				yr := Obj(n2,Y)-Obj(n1,Y)
				rr := sqrt{xr^2+yr^2}	$$ center-to-center distance
			if	rr <= Obj(n1,R)+Obj(n2,R) & Obj(n2,M) > 0   $$ detected a collis@
ion
				calc	temp := Obj(n1,M)+Obj(n2,M)
					Obj(n1,VX) := [Obj(n1,M)*Obj(n1,VX)+Obj(n2,M)*Obj(n2,VX)]/temp
					Obj(n1,VY) := [Obj(n1,M)*Obj(n1,VY)+Obj(n2,M)*Obj(n2,VY)]/temp
					Obj(n1,X) := [Obj(n1,M)*Obj(n1,X)+Obj(n2,M)*Obj(n2,X)]/temp
					Obj(n1,Y) := [Obj(n1,M)*Obj(n1,Y)+Obj(n2,M)*Obj(n2,Y)]/temp
					Obj(n1,M) := temp
					Obj(n1,R) := MTOR*Obj(n1,M)^(1/3)
					Obj(n2,M) := Obj(n2,R) := 0	$$ make this mass "disappear"
			endif
		endloop
	endloop
endif

loop	n1 := 1, nmasses	$$ now step position for each object
	calc	Obj(n1,X) := Obj(n1,X)+Obj(n1,VX)*DT
		Obj(n1,Y) := Obj(n1,Y)+Obj(n1,VY)*DT
endloop
if	ShowEnergy	$$ display bar graphs of energy
	mode	write
	do	ShowEnergy(pe,ke,SHOW)
	do	OrbitCoordinates
endif
********************
@1pl8000unit	GetInitialConditions(nobj)  $$ click and drag mouse to se@
t initial position and velocity
@1pl4001	merge,masses:
	integer: nobj
	float: x0,y0,x,y,mratio

if	RunFromFile
	$$ this time, use previous data, or data from file:
	block	Initial,Obj
	color	zblack
	mode	write
	if	AtPause		$$ if chose "Repeat orbit" while waiting at -pause- below
		outunit		$$ don't wait for additional mouse click to start plotting
	endif
	if	Type = 3 & nobj = 2	$$ don't wait for a click if 2nd object of two@
 moving objects
		outunit
	endif
	erase	0,0;165,20	$$ erase "Drag to set initial conditions"
	at	1,1
	write	Click to start plotting
	pause	keys=touch(left: up)	$$ "swallow" clicking down, wait for relea@
se of mouse button
	outunit			  
endif

calc	AtPause := TRUE	$$ signal that user is waiting at the following -@
pause- command:
pause	keys=touch		$$ wait for user to click somewhere
calc	x0 := zgtouchx	$$ mouse location in graphing coordinates (-gorigi@
n-, etc.)
	y0 := zgtouchy	$$ x0,y0 is the tail of the velocity vector
set	Obj(nobj,X) := x0,y0	$$ set initial position for specified object
do	ShowObjects(FALSE)	$$ show all objects, not in "exclusive or" mode
cursor	zcursors,3		$$ choose invisible cursor
mode	xor		$$ "exclusive or" mode for dragging vector across background
color	zblack
* Now drag mouse to define velocity vector graphically:
loop
	calc	x := zgtouchx	$$ tip of the velocity vector in graphing coordina@
tes
		y := zgtouchy
	gvector	x0,y0; x,y; 10	$$ display new velocity vector
	if	Type = 2	$$ orbiting around their center of mass, display other ve@
locity vector
		$$ adjust object one velocity to make center of mass of 2 objects be@
 stationary
		calc	Obj(1,VX) := -[Obj(2,M)*(x-x0)]/Obj(1,M)
			Obj(1,VY) := -[Obj(2,M)*(y-y0)]/Obj(1,M)
		gvector	Obj(1,X),Obj(1,Y); Obj(1,X)+Obj(1,VX),Obj(1,Y)+Obj(1,VY);10
	
	elseif	Type = 5	$$ adjust velocity of object 1 to make center of mass@
 not move
		$$ adjust object one velocity to make center of mass of 3 objects be@
 stationary
		calc	Obj(1,VX) := -[Obj(2,M)*Obj(2,VX)+Obj(3,M)*(x-x0)]/Obj(1,M)
			Obj(1,VY) := -[Obj(2,M)*Obj(2,VY)+Obj(3,M)*(y-y0)]/Obj(1,M)
		gvector	Obj(1,X),Obj(1,Y); Obj(1,X)+Obj(1,VX),Obj(1,Y)+Obj(1,VY);10
	endif
	pause	keys=touch(left:move,up)  $$ wait for mouse drag or releasing m@
ouse button
	gvector	x0,y0; x,y; 10	$$ in mode xor, redisplay causes vector to be @
erased
	if	Type = 2	$$ orbiting around their center of mass, display other ve@
locity vector
		gvector	Obj(1,X),Obj(1,Y); Obj(1,X)+Obj(1,VX),Obj(1,Y)+Obj(1,VY);10
	
	elseif	Type = 5	$$ adjust velocity of object 1 to make center of mass@
 not move
		gvector	Obj(1,X),Obj(1,Y); Obj(1,X)+Obj(1,VX),Obj(1,Y)+Obj(1,VY);10
	endif
	outloop	zkey=zk(left:up)	$$ leave when user releases the left mouse b@
utton
endloop
if	Type = 3 & nobj = 1	$$ keep  velocity of object 1 in view while set@
ting velocity for object 2
	gvector	x0,y0; x,y; 10
endif
mode	write		$$ cancel "exclusive or" mode
cursor			$$ restore normal cursor
set	Obj(nobj,VX) := x-x0,y-y0	$$ set initial velocity for specified ob@
ject
* transfer x, y, v@1fsffec@1ff  20x@1fs8000@1ff8000, v@1fsffec@1ff  20@
y@1fs8000@1ff8000 to Initial array; use in 2nd orbit try:
block	Obj, Initial
********************
@1pl8000unit	ShowObjects(xormode)   $$ display current positions of ob@
jects
@1pl4001	merge,masses:
	integer: xormode	$$ TRUE if "exclusive or" mode
	integer: nobj
loop	nobj := 1, NOBJS
	if	xormode & ~Obj(nobj,FIXED)
		mode	xor
		color	zblack
	else
		mode	write
		color	Obj(nobj,COLOR)
	endif
	gatnm	Lastxy(nobj,X) := Obj(nobj,X),Lastxy(nobj,Y) := Obj(nobj,Y)
	gdisk	Lastxy(nobj,R) := Obj(nobj,R)
endloop
*********************
@1pl8000unit	ShowEnergy(pe,ke,method)	$$ show KE, PE, and total energy@
 PE+KE
@1pl4001	merge,energy:
	f: pe, ke
	i: method
	f: KEX=0, PEX=40, TEX=80, BASE=0, WIDTH=15
	f: LABELY=0
	i: Xpe, Ype
do	EnergyCoordinates
case	method
LABEL
	gerase	KEX-1,LABELY; TEX+WIDTH+1,BASE+EMAX
	color	zblue
	gat	KEX-20,LABELY
	write	@1ff   1KE@1ff8000
	color	zred
	gat	PEX-20,LABELY
	write	@1ff   1PE@1ff8000
	color	zblack
	gat	TEX-20,LABELY
	write	@1ff   1KE
		 +
		PE@1ff8000
	gdraw	KEX-3,BASE; TEX+WIDTH+3,BASE
SETPE
	calc	PE := pe
		KE := ke
		TE := pe+ke
	gerase	KEX-1,LABELY; TEX+WIDTH+1,BASE+EMAX
	color	zblack
	gdraw	KEX-3,BASE; TEX+WIDTH+3,BASE
	gfill	TEX,BASE; TEX+WIDTH,TE
	color	zred
	gfill	PEX,BASE;PEX+WIDTH,PE
	if	KE > 0
		color	zblue
		gfill	KEX,BASE;KEX+WIDTH,BASE+KE
	endif
SETKE
	color	zblue
	if	ke > KE
		gfill	KEX,BASE+KE;KEX+WIDTH,BASE+ke
	else
		gerase	KEX,BASE+KE;KEX+WIDTH,BASE+ke
	endif
	color	zblack
	if	TE < BASE
		if	PE+ke < TE
			gfill	TEX,TE;TEX+WIDTH,PE+ke
		elseif	PE+ke < BASE
			gerase	TEX,TE;TEX+WIDTH,PE+ke
		else
			gerase	TEX,TE;TEX+WIDTH,BASE
			gfill	TEX,BASE;TEX+WIDTH,PE+ke
		endif
	else
		if	PE+ke > TE
			gfill	TEX,TE;TEX+WIDTH,PE+ke
		elseif	PE+ke > BASE
			gerase	TEX,TE;TEX+WIDTH,PE+ke
		else
			gerase	TEX,TE;TEX+WIDTH,BASE
			gfill	TEX,BASE;TEX+WIDTH,PE+ke
		endif
	endif
	calc	KE := ke
		TE := PE+KE
SHOW
	color	zblue
	if	ke > KE
		gfill	KEX,BASE+KE;KEX+WIDTH,BASE+ke
	else
		gerase	KEX,BASE+KE;KEX+WIDTH,BASE+ke
	endif
	color	zred
	if	PE < BASE
		if	pe < PE
			gfill	PEX,PE;PEX+WIDTH,pe
		elseif	pe < BASE
			gerase	PEX,PE;PEX+WIDTH,pe
		else
			gerase	PEX,PE;PEX+WIDTH,BASE
			gfill	PEX,BASE;PEX+WIDTH,pe
		endif
	else
		if	pe > PE
			gfill	PEX,PE;PEX+WIDTH,pe
		elseif	pe > BASE
			gerase	PEX,PE;PEX+WIDTH,pe
		else
			gerase	PEX,PE;PEX+WIDTH,BASE
			gfill	PEX,BASE;PEX+WIDTH,pe
		endif
	endif
	color	zblack
	if	TE < BASE
		if	pe+ke < TE
			gfill	TEX,TE;TEX+WIDTH,pe+ke
		elseif	pe+ke < BASE
			gerase	TEX,TE;TEX+WIDTH,pe+ke
		else
			gerase	TEX,TE;TEX+WIDTH,BASE
			gfill	TEX,BASE;TEX+WIDTH,pe+ke
		endif
	else
		if	pe+ke > TE
			gfill	TEX,TE;TEX+WIDTH,pe+ke
		elseif	pe+ke > BASE
			gerase	TEX,TE;TEX+WIDTH,pe+ke
		else
			gerase	TEX,TE;TEX+WIDTH,BASE
			gfill	TEX,BASE;TEX+WIDTH,pe+ke
		endif
	endif
	calc	PE := pe
		KE := ke
		TE := PE+KE
endcase
*********************
@1pl8000unit	EnergyCoordinates	$$ gorigin, scale factors for plotting @
energy
@1pl4001	merge,energy:
	i: W=100
gorigin	zxmax-W,zymax/2
bounds	W,zymax/2-20
scalex	W
scaley	EMAX
*********************
@1pl8000unit	OrbitCoordinates	$$ establish graphing (real-world) coord@
inates
@1pl4001gorigin	zxmax/2, zymax/2	   $$ establish graphing coordinates;@
 origin in center of window
bounds	-100,-100; 100, 100  $$ like -axes- but doesn't actually draw t@
he axes
scalex	1	$$ choose length units so that a portion of the screen has le@
ngth 1
scaley	1
*********************
@1pl8000unit	jSetTimeInterval	$$ menu unit
@1pl4001* A menu choice is the equivalent of a -do- (like executing a @
subroutine).
* We do a -jump- to unit SetTimeInterval in order to erase the screen
*    and establish a context for entering numerical choices.
jump	SetTimeInterval
********************
@1pl8000unit	SetTimeInterval	$$ specify time interval DT and dot count
@1pl4001	merge,masses:
	float: input
color	zblack
mode	write
thick	1		$$ so "arrow" prompt not drawn thick
at	20,20
write	Enter the time interval (typical value is 0.01).  
at	35,50
write	Press RETURN to keep current value of <|s,DT|>:  
allow	blanks
arrow	     $$ display "arrowhead" prompt, await input terminated by Re@
turn
answer			$$ blank input; keep current value
compute	input		$$ compute the input value
ok	zreturn		$$ if valid input, execute indented code, then branch past@
 -endarrow-
	calc	DT := input
no			$$ invalid input, await Return or Erase to correct the input
	write	Invalid value.
endarrow
at	20,100
write	Plot a dot every nth time interval.
at	35,130
write	Enter 0 for no dots; press RETURN to keep current value of n = <@
|s,MaxDTcount|>:  
allow	blanks
arrow	     $$ display "arrowhead" prompt, await input terminated by Re@
turn
answer			$$ blank input; keep current value
compute	input		$$ compute the input value
ok	zreturn		$$ if valid input
	calc	MaxDTcount := input
no
	write	Invalid value.
endarrow
if	Type > 0		$$ if a situation has already been chosen
	do	Repeat
endif
* No situation chosen yet, wait for menu choice:
at	40,180
write	@1ff   0@1cl   4Choose a situation from the pull-down menu@
@1ff8000@1cl8000
********************
@1pl8000unit	jSetMasses		$$ menu unit
@1pl4001* A menu choice is the equivalent of a -do- (like executing a @
subroutine).
* We do a -jump- to unit SetMasses in order to erase the screen
*    and establish a context for entering numerical choices.
jump	SetMasses
********************
@1pl8000unit	SetMasses		$$ specify masses
@1pl4001	merge,masses:
	float: input
	i: nmass
color	zblack
mode	write
thick	1		$$ so "arrow" prompt not drawn thick
loop	nmass := 1, 3
	at	20,20+(nmass-1)*80
	write	Enter mass of 
	write	\nmass-2\first\second\third
	write	 object (typical value is 
	write	\nmass-2\2\1\0.1
	write	).
	at	35,50+(nmass-1)*80
	write	Press RETURN to keep current value of <|s,Obj(nmass,M)|>:  
	allow	blanks
	arrow	     $$ display "arrowhead" prompt, await input terminated by R@
eturn
	answer			$$ blank input; keep current value
	compute	input		$$ compute the input value
	ok	zreturn		$$ if valid input, execute indented code, then branch pas@
t -endarrow-
		calc	Initial(nmass,M) := Obj(nmass,M) := input
			Initial(nmass,R) := Obj(nmass,R) := MTOR*input^(1/3)
	no			$$ invalid input, await Return or Erase to correct the input
		write	Invalid value.
	endarrow
endloop
if	Type > 0		$$ if a situation has already been chosen
	do	Repeat
endif
* No situation chosen yet, wait for menu choice:
at	40,260
write	@1ff   0@1cl   4Choose a situation from the pull-down menu@
@1ff8000@1cl8000
********************
@1pl8000unit	ChooseEnergyGraphs	$$ menu unit to specify whether to sho@
w energy bar graphs
@1pl4001	merge,energy:
if	ShowEnergy
	menu	Choose Situation; Don't show energy bar graphs
	menu	Choose Situation; Show energy bar graphs,23: ChooseEnergyGraphs
else
	menu	Choose Situation; Show energy bar graphs
	menu	Choose Situation; Don't show energy bar graphs,23: ChooseEnergyG@
raphs
endif
calc	ShowEnergy := not(ShowEnergy)
********************
@1pl8000unit	Repeat		$$ repeat previous orbit
@1pl4001	merge,masses:
	integer: nobj
outunit	Type = 0		$$ if no situation chosen yet, nothing to repeat
block	Initial,Obj		$$ restore initial conditions
if	~AtPause		$$ if had actually been plotting motion
	calc	RunFromFile := TRUE	$$ use initial conditions from file, don't a@
sk user for input
endif
jump	Main
********************
@1pl8000unit	SetSituation(settype)	$$ menu unit; set initial condition@
s, then jump to Main
@1pl4001	merge,masses:
	integer: settype
	integer: nobj
calc	Type := settype
	RunFromFile := FALSE		$$ get initial conditions from user
do	SetInitialConditions		$$ for all objects except for the one set by @
dragging the mouse
loop	nobj := 1, NOBJS
	set	Initial(nobj,X) := OFFSCREEN,OFFSCREEN,0,0  $$ off screen, so no @
initial vector the first time
endloop
jump	Main
********************
@1pl8000unit	SetInitialConditions	$$ for all objects except for the on@
e set by dragging the mouse
@1pl4001	merge,masses:
* The following is a "conditional" command. If Type < 0, do nothing; i@
f Type = 0, do nothing;
*    if Type = 1, do TwoWithOneMoving; if Type = 2, do TwoMovingAboutC@
M; etc.
do	\Type\x\x\TwoWithOneMoving\TwoMovingAboutCM
	\TwoMoving\TwoFixedAndOneMoving\ThreeMoving
********************
@1pl8000unit	TwoWithOneMoving	$$ Two objects, one fixed and one moving
@1pl4001	merge,masses:
	float: m1, m2, m3
calc	m1 := Obj(1,M)
	m2 := Obj(2,M)
	m3 := Obj(3,M)
* The -set- command is convenient for initializing an array of values.@
 It is equivalent to a bunch of -calc-s.
* For example, "set  Obj := -0.5, 0,  0,  0, 2, 0.125, zred, TRUE, ...@
" has the same effect as the following calculations:
*          Obj(1,1) := -0.5, Obj(1,2) := 0, Obj(1,3) := 0, Obj(1,4) :=@
 0, Obj(1,5) := 2, Obj(1,6) := 0.125, etc.

set	Obj := -0.5,0,   0,0,                             m1, MTOR*m1^(1/3@
), zred, TRUE,
	           OFFSCREEN,OFFSCREEN, 0, 0,   m2, MTOR*m2^(1/3), zblue, FAL@
SE,    $$ x,y,vx,vy to be set by dragging mouse
	           OFFSCREEN,OFFSCREEN, 0, 0,   m3, 0, 0, TRUE               @
 $$ effectively there is no third object
********************
@1pl8000unit	TwoMovingAboutCM	$$ Two objects, both moving around a fix@
ed center of mass
@1pl4001	merge,masses:
	float: m1, m2, m3
calc	m1 := Obj(1,M)
	m2 := Obj(2,M)
	m3 := Obj(3,M)
set	Obj := -0.5,0,   0,0,	                           m1, MTOR*m1^(1/3)@
, zred, FALSE,
	           OFFSCREEN,OFFSCREEN, 0, 0,    m2, MTOR*m2^(1/3), zblue, FA@
LSE,    $$ x,y,vx,vy to be set by dragging mouse
	           OFFSCREEN,OFFSCREEN, 0, 0,    m3, 0, 0, TRUE              @
  $$ effectively there is no third object
********************
@1pl8000unit	TwoMoving		$$ Two objects, both moving (drag mouse to set@
 initial conditions for both)
@1pl4001	merge,masses:
	float: m1, m2, m3
calc	m1 := Obj(1,M)
	m2 := Obj(2,M)
	m3 := Obj(3,M)
set	Obj := OFFSCREEN,OFFSCREEN, 0, 0,     m1, MTOR*m1^(1/3), zred, FAL@
SE,  $$ x,y,vx,vy to be set by dragging mouse
	           OFFSCREEN,OFFSCREEN, 0, 0,     m2, MTOR*m2^(1/3), zblue, F@
ALSE,    $$ x,y,vx,vy to be set by dragging mouse
	           OFFSCREEN,OFFSCREEN, 0, 0,     m3, 0, 0, TRUE             @
   $$ effectively there is no third object
********************
@1pl8000unit	TwoFixedAndOneMoving  $$ Three objects, two fixed and one@
 moving
@1pl4001	merge,masses:
	float: m1, m2, m3
calc	m1 := Obj(1,M)
	m2 := Obj(2,M)
	m3 := Obj(3,M)
set	Obj := -1,0,   0,  0,		       m1, MTOR*m1^(1/3), zred, TRUE,
	           1,0,   0,0,		       m2, MTOR*m2^(1/3), zmagenta, TRUE,
	           OFFSCREEN,OFFSCREEN, 0, 0,   m3, MTOR*m3^(1/3), zblue, FAL@
SE   $$ x,y,vx,vy to be set by dragging mouse
********************
@1pl8000unit	ThreeMoving	$$ Three objects, all three moving
@1pl4001	merge,masses:
	float: m1, m2, m3
calc	m1 := Obj(1,M)
	m2 := Obj(2,M)
	m3 := Obj(3,M)
set	Obj := -0.5,0,   0,0.6,	       m1, MTOR*m1^(1/3), zred, FALSE,
	           0.5,0,   0,-1.2,	       m2, MTOR*m2^(1/3), zmagenta, FALSE@
,
	           OFFSCREEN,OFFSCREEN, 0, 0,   m3, MTOR*m3^(1/3), zblue, FAL@
SE   $$ x,y,vx,vy to be set by dragging mouse
**********
@1pl8000unit	SaveSituation	$$ save current situation in a file
@1pl4001	merge,masses:
	file: output
	screen: save
outunit	Type = 0
addfile	output; zempty	$$ choose file name, create new file
if	~zreturn		$$ don't continue if file not created successfully
	do	ErrorMessage("File not created")
	outunit
endif
setdir	zfilepath(output)	$$ set to this directory or folder for the fu@
ture
dataout	output; Type	$$ save type of situation
if	~zreturn		$$ don't continue if file cannot be written
	do	ErrorMessage("Cannot save data in file")
	outunit
endif
dataout	output; Initial	$$ save initial conditions
if	~zreturn		$$ don't continue if file cannot be written
	do	ErrorMessage("Cannot save data in file")
	outunit
endif
********************
@1pl8000unit	GetSituation	$$ get a situation saved in a file
@1pl4001	merge,masses:
	file: input
setfile	input; zempty;ro	$$ choose file name, open existing file, read@
-only
if	~zreturn		$$ don't continue if file not created successfully
	if	zreturn = 17	$$ user canceled file choice
		outunit
	endif
	do	ErrorMessage("File not found")
	outunit
endif
setdir	zfilepath(input)	$$ set to this directory or folder for the fut@
ure
datain	input; Type	$$ get type of situation
if	~zreturn | ~(1 <= Type <= 5) $$ don't continue if file data bad
	do	ErrorMessage("File data incorrect")
	outunit
endif
datain	input; Initial	$$ get initial conditions
if	~zreturn		$$ don't continue if file cannot be written
	do	ErrorMessage("Cannot read data from file")
	outunit
endif
do	Repeat
********************
@1pl8000unit	PrintScreenSetup	$$ page setup for printing
@1pl4001dialog	page setup
*zreturn is -1 if the dialog box worked, set as for file errors otherw@
ise.
*zretinf is 0 if the dialog box did not work, 1 if the OK button was p@
ressed, 2 if the CANCEL button was pressed.
outunit	zretinf = 2
if	~zreturn
	do	ErrorMessage("Print setup failed")
	outunit
endif
************
@1pl8000unit	PrintScreen	$$ print bitmap image of screen
@1pl4001	screen: image
	m: print
get	image; zxmin,zymin; zxmax,zymax
style	print; screen,image
dialog	print
*zreturn is -1 if the dialog box worked, set as for file errors otherw@
ise.
*zretinf is 0 if the dialog box did not work, 1 if the OK button was p@
ressed, 2 if the CANCEL button was pressed.
outunit	zretinf = 2
if	~zreturn
	do	ErrorMessage("Print request failed")
	outunit
endif
print	print
if	~zreturn
	do	ErrorMessage("Print attempt failed")
	outunit
endif
********************
@1pl8000unit	ErrorMessage(message)  $$ give message about file or othe@
r error
@1pl4001	m: message
dialog	ok, message
**********
@1pl8000unit	DummyMenu	$$  empty unit referenced by pull-down menu
@1pl4001********************
@1pl8000unit	Quit		$$ quit the program
@1pl4001jumpout
@cT end
