@cT datastream 1
$syntaxlevel 2

* Bruce Arne Sherwood
* Center for Innovation in Learning
* Dept. of Physics
* Harry Stumpf and Bradley Keister
* Dept. of Physics
* Carnegie Mellon University
* Pittsburgh PA 15213

* The original version of this program was written
* by Bruce Sherwood in 1985, very early in the
* development of  cT.
* The program let the user design a step-wise
* potential well for an electron, then specify a
* trial energy level looking for a solution to the
* quantum mechanics equation that matches the
* required boundary conditions (function should
* go to zero at infinity). 

* Harry Stumpf and Bradley Keister modified it
* to perform an automatic search
* for valid energy values, and to offer a
* selection of analytic potentials such as the
* harmonic oscillator potential.  Bruce Sherwood
* rewrote the automatic search to be based on
* finding nodes, which solved a problem with
* skipping levels when they were close together.

* The program has been used for lecture demonstrations
* and student exploration in physics courses at
* Carnegie Mellon University.

* Do whatever you like with this program.
* Feel free to make copies of it or to modify it.

* We would be pleased to receive an improved version!

@1ff   1* To see one or more hidden units, select units with mouse, th@
en
*   choose "Show Units" on Edit menu. Or choose "Show All Units".@
@1ff8000

define	f: k1
	edgex(30), edgey(30), nedges  $$ edges of step-wise well
	E, psi, dpsi  $$ energy, wave function, derivative of wave function
	prob $$ probability = integral of psi*psi
	xmax, Emax, xmiddle
	wellminimum, wellmaximum
* Don't include final exponential region when computing normalization,
* because in that region the (improper) wave function may be huge:
	i: nprob  $$ last step to include in normalization calculation
	i: search  $$ TRUE if doing automatic search for eigenvalues
	i: state
	i: iswitch  $$ 1 harmonic oscillator, 2 square well, 3 infinite squar@
e well
	f: shoscalefact
	f: iwidth, idepth, bheight, bwidth, spacing, cscfactor
	i: bnumber  $$ number of barriers in multiwell situation
	f: lastenergy  $$ previous trial energy in automatic search
	i: CR = 18  $$ height of a carriage return
	i: QX = 180, QY = 120  $$ loc. of questions on depth, width, etc.
	i: numchoices = 5  $$ number of types of wells to choose from
*  Coordinates of box labeled "Stop the Search"
	i: STOPX1 = 195, STOPY1 = 10
	i: STOPX2 = 323, STOPY2 = 40

* Search for eigenvalues by looking at the number of nodes of the wave@
 function
	i: MAXNODES = 15   $$ max number of nodes looked for
	f: Elower(-1:MAXNODES)  $$ lower bound on E for node n
	f: Eupper(-1:MAXNODES)  $$ upper bound on E for node n
* Determined by trial wave-function plotting:
	i: nodes  $$ no. of nodes found

calc	xmax:=2.5  $$ well goes from 0 to 2.5 nanometers
	Emax:=10  $$ depth of 10 electron Volts
	nedges:=1
	edgex(1):=1 
	shoscalefact := .5   
	xmiddle := xmax/2         
	k1 := sqrt(2*.511)/(.197)
*	k1 := 32PI*sqrt(.511)/(6.63*3)  $$ k (1/nm) for (E-V=1eV)
font	zsans, CR
fine	560,400
rescale	TRUE,TRUE,TRUE,TRUE
************************************************
unit	intro
@1pl4001next	describe
menu	Introduction
menu	Skip introduction:predraw
enable	touch
text	0,85;560,400
@1ff   1@1pl4003QUANTUM WELL@1ff8000

Bruce Sherwood, Harry Stumpf, and Bradley Keister
Department of Physics
Carnegie Mellon University
1985, 1987, 1988, 1997

You are welcome to make copies of this program.

(You can use the menu to skip the introduction.)

@1ff   1Click anywhere, or press Return, to proceed
through the introduction.@1ff8000
@1pl4001\
************************************************
@1pl8000unit	preintro  $$ menu unit
@1pl4001jump	intro
************************************************
@1pl8000unit	describe
@1pl4001next	describe1
back	intro
enable	touch
text	88,166;490,324
@1pl4007This program lets you set up a quantum well and search for all@
owed energy states for an electron in the well.
@1pl4001\
calc	state:=0
************************************************
@1pl8000unit	describe1
@1pl4001next	describe2
back	describe
enable	touch
text	100,79;445,201
@1pl4007Here is what a typical well might look like:
@1pl4001\
do	setup1
do	showwell
if	state = 0
	pause	keys=all,touch
	calc	state:=1
endif
erase	100,79;445,130
text	75,59;236,201
@1pl4007You will use the mouse to choose corners of the well:
@1pl4001\
vector	174,104;197,175; -20
pause	keys=all,touch
vector	214,103;272,343; -20
pause	.5
vector	296,100;349,294; -20
pause	.5
vector	457,100;433,175; -20
text	363,37;522,191
@1pl4007Your last point should be far to the right to show you are don@
e.
@1pl4001\
************************************************
@1pl8000unit	setup1
@1pl4001	merge,global:
	f:i
gorigin	128,181
bounds	300,170
scalex	xmax  $$ nm
scaley	Emax  $$ eV
calc	nedges:=5
	iswitch:=numchoices
loop	i:=1, 5
.	calc	edgex(i):=(i-1)*xmax/4
endloop
calc	edgey(1):=edgey(2):=0
	edgey(3):=-Emax
	edgey(4):=-.7Emax
	edgey(5):=0
************************************************
@1pl8000unit	describe2
@1pl4001next	describe3
back	describe1
enable	touch
text	66,23;481,181
@1pl4007After designing a well, you will use the mouse to choose an en@
ergy level.
@1pl4001\
do	setup1
gorigin	119,120
do	showwell
pause	keys=all,touch
loop	E:=-2,-.9*Emax,-Emax/10
.	gvector	0,E;.4,E
.	pause	.02
.	mode	erase
.	gvector	0,E;.4,E
.	mode	write
endloop
mode	write
vector	115,195;153,272
calc	E:=-9.4198119
gdraw	0,E; xmax,E
pause	keys=all,touch
text	179,325;402,467
@1pl4007Then we will integrate the wave equation thru the well.
@1pl4001\
pause	keys=all,touch
do	plotwave(-Emax,0)
vector	384,210;347,268
text	359,142;505,310
@1pl4007This is a solution:  the wave function goes to zero for large @
x.
@1pl4001\
************************************************
@1pl8000unit	describe3
@1pl4001back	describe2
next	describe4
enable	touch
text	57,17;488,165
@1pl4007Usually, though, the trial function won't go to zero:
@1pl4001\
do	setup1
gorigin	119,120
do	showwell
calc	E:=-4.8
gdraw	0,E; xmax,E
do	plotwave(-Emax,0)
pause	keys=all,touch
vector	432,287;377,187
text	314,295;536,478
@1pl4007When this happens, you must try a different trial energy, look@
ing for an energy that yields a vanishing wave function for large x.
@1pl4001\
************************************************
@1pl8000unit	describe4
@1pl4001back	describe3
next	predraw
enable	touch
text	55,54;505,116
@1pl4007Drawing a step-function well with the mouse isn't the only way@
 you can set up a potential.  You can also choose among these wells:
@1pl4001\
text	133,136;486,271
@1pl4007Finite square well(s), numerically specified

Infinite square well

Simple harmonic oscillator
@1pl4001\
text	55,260;505,400
@1pl4007In all of these cases you can use the mouse to hunt for an ene@
rgy level.

You can also ask the program to hunt for energy levels, which is slow @
but more precise than what you can do by hand.
@1pl4001\
************************************************
@1pl8000unit	predraw
@1pl4001	merge,global:
menu	Skip introduction
menu	Introduction:preintro
calc	nedges:=1
	edgex(1):=0
	wellminimum := 0
	wellmaximum := 0
	E:=20000
	iswitch:=numchoices
	search := FALSE
jump	drawwell
************************************************
@1pl8000unit	predraw2
@1pl4001jump	\nedges = 1\describe4\predraw
************************************************
@1pl8000unit	drawwell    $$ display the well and/or get well design in@
put
@1pl4001	merge,global:
	f:enmin,enmax, input
	f:clear,design,eigen
back	predraw2
do	scalewell
do	showwell
if	edgex(nedges)<=(xmax-.25)
.	do	getwell(;enmin,enmax)
.	calc	wellminimum := enmin
.		wellmaximum := enmax
endif
if	search	$$ Find eigenvalue (automatic search)
.	box	STOPX1,STOPY1; STOPX2,STOPY2
.	text	STOPX1,STOPY1+(30-CR)/2;STOPX2,STOPY2
@1pl4003Stop the search
@1pl4001\
.	clrkey	$$ will use zkey as an exit flag when selected "Stop the Sear@
ch"
.	if	iswitch = numchoices | iswitch = 2  $$ mouse-drawn or finite squa@
re well(s)
.	.	do	eigenval1(wellminimum, wellmaximum)
.	elseif	iswitch = 3 | iswitch = 1  $$ harmonic or infinite -- known e@
nergies
.	.	do	eigenval2(wellminimum, wellmaximum)
.	endif
.	erase	0,0;560,50
endif
do	welloptions  $$ show clear, search, redesign button options
if	~search & (wellminimum< E < wellmaximum)
	do	plotwave(wellminimum, wellmaximum)
endif
calc	search := FALSE
at	24,371
write	Or type E =  
enable	touch
inhibit	anserase
arrow	
no	zkey=zk(touch)
.	do	touch(14,10,142,40;clear)
.	do	touch(185,10,333,40;eigen)
.	do	touch(377,10,505,40;design)
.	if	clear
.	.	jump	drawwell
.	elseif	design
.	.	jump	predraw
.	elseif	eigen
.	.	calc	search := TRUE
.	.	jump 	drawwell
.	endif
.	calc	E := zgtouchy
.	do	plotwave(wellminimum, wellmaximum)
.	judge	ignore
compute	input
no	zreturn
.	calc	E := input
.	if	iswitch = numchoices | iswitch = 2  $$ mouse-drawn or finite squa@
re well(s)
.	.	if	~(wellminimum < input <= wellmaximum)
.	.	.	judge	noquit
.	.	endif
.	else	$$ harmonic or infinite
.	.	if	~(0 < input <= Emax)
.	.	.	judge	noquit
.	.	endif
.	.	calc	E := input-Emax
.	endif
.	do	plotwave(wellminimum, wellmaximum)
.	specs	nookno
endarrow
************************************************
@1pl8000unit	welloptions
@1pl4001erase	50,180;110,260
box	50,180;110,260;2
text	50,180+(260-180-4CR)/2;110,300
@1pl4003Click
an
energy
level:
@1pl4001\
erase	13,9;143,41
erase	194,9;324,41
erase	376,9;506,41
box	14,10;142,40;2
text	14,10+(30-CR)/2;142,40
@1pl4003Clear screen
@1pl4001\
box	185,10;333,40;2
text	185,10+(30-CR)/2;333,40
@1pl4003Find energy levels
@1pl4001\
box	377,10;505,40;2
text	377,10+(30-CR)/2;505,40
@1pl4003Redesign well
@1pl4001\
************************************************
@1pl8000unit	plotwave(enmin, enmax)  $$ plot for different types of we@
ll
@1pl4001	merge,global:
	f: enmin, enmax
	f: n, k,ylast,dy1last,ymax,xfirst,xlast
	f: drawinc,nminus,nplus,frac,yminus,dy1minus,yplus
	f: dy1plus,yfirst,dy1first
gdraw	0,E; xmax,E
if	iswitch=numchoices | iswitch=2
	if	~(enmin < E < enmax)
	.	gat	0,E
	.	write	No bound state
	.	outunit
	endif
	gat	0,E
	showt	E,3,4
else
	gat	0,E
	showt	E+Emax,3,4   $$bottom of  oscillator and infinite well is actua@
lly 0
endif
case	iswitch
numchoices, 2  $$ finite well(s)
	do	plotwaveb
3   $$ infinite well
.	calc	psi:=0
.		dpsi:=6*sqrt(E+Emax)
.	gat	edgex(2),E+psi
.	do	trig(3,TRUE)
1  $$ simple harmonic oscillator
.	calc	xfirst:=xmiddle-sqrt(E+Emax)*2/(k1*spacing)-.4
.	if	xfirst<0
.	.	calc	xfirst:=0
.	endif
.	calc	xlast:=xmax
.		yfirst:=.0001
.		dy1first:=.0001
.	do	runge(xfirst,yfirst,dy1first,E,.001,iswitch,TRUE,0,xmiddle;ylast,@
dy1last,ymax)
.	calc	yfirst:=shoscalefact*1.5*yfirst/ymax
.		dy1first:=shoscalefact*1.5*dy1first/ymax
.	do	runge(xfirst,yfirst,dy1first,E,.0000001,iswitch,FALSE,.04,xlast;y@
last,dy1last,ymax)
endcase
************************************************
@1pl8000unit	plotwaveb
@1pl4001do	prewave  $$ find normalization (probability) and nodes
do	showwave  $$ integrate and show the wave function
*********
@1pl8000unit	prewave  $$ integrate left to right just to find normaliz@
ation and nodes
@1pl4001	merge,global:
	f: k, saveprob, savenodes, saveedge
	i: n, nfinal
calc	k:=k1*sqrt(edgey(1)-E)
	psi:=.01
	dpsi:=k*psi
	prob:=0
	nodes := 0  $$ number of nodes in this wave function
calc	nprob := nedges+1
loop	(nprob := nprob-1) > 1
.	outloop	E > edgey(nprob)
endloop
calc	nfinal := nedges
if	search  $$ when searching for levels, make "+infinity" not too far @
away
	if	nprob < nedges
		calc	nfinal := nprob+1
	endif
	calc	saveedge := edgex(nfinal)
	if	saveedge + .3 > edgex(nfinal)
		calc	edgex(nfinal) := edgex(nprob) + .3
	endif
endif
loop	n:=2, nfinal  $$ calculate normalization
.	if	E<edgey(n)
.	.	do	expon(n,FALSE)
.	elseif	E>edgey(n)
.	.	do	trig(n,FALSE)
.	else
.	.	do	linear(n,FALSE)
.	endif
.	if	n = 2
.	.	calc	prob := 0
.	elseif	n = nprob  $$ probability calculation doesn't include final e@
xponential region
.	.	calc	saveprob := prob
.	.		savenodes := nodes
.	endif
endloop
calc	prob := saveprob
	nodes := savenodes
if	search
	calc	edgex(nfinal) := saveedge
endif
*********
@1pl8000unit	showwave	$$ choose exponential, sinusoidal, or linear sol@
ution
@1pl4001	merge,global:
	f: k
	i: n
calc	k:=k1*sqrt(edgey(1)-E)
	psi:=.008/sqrt(prob)
	dpsi:=k*psi
inhibit	startdraw
loop	n:=2, nedges  $$ plot wave function
.	if	E<edgey(n)
.	.	do	expon(n,TRUE)
.	.	outloop	abs(psi)>100
.	elseif	E>edgey(n)
.	.	do	trig(n,TRUE)
.	else
.	.	do	linear(n,TRUE)
.	endif
endloop
************************************************
@1pl8000unit	plotwave2(n)
@1pl4001.	merge,global:
.	f:n,i,nfact,beta,herm,betax,x,y,numinc,dx
gdraw	0,E; xmax,E
gat	0,E
showt	E+Emax,3,4
calc	beta := k1*sqrt(spacing/2)
do	nfactorial(n;nfact)
calc	numinc := 30*sqrt(n+1)*spacing**.25
	dx := (xmax+.15)/numinc
	x := 0
inhibit	startdraw
loop	i:=0,numinc
.	calc	betax := beta*(x-xmiddle)
.	do	hermite(betax,n;herm)
.	calc	y:=shoscalefact*sqrt(beta/(sqrt(PI)*2**n*nfact))* exp(-betax*be@
tax/2)*herm
.	gdraw	;x,y+E
.	calc	x:=x+dx
endloop
************************************************
@1pl8000unit	getphi(n,x;y,dy1)
@1pl4001.	merge,global:
.	f:n,nfact,beta,herm,betax,x,y,dy1,coef,expon
calc	beta:=k1*sqrt(spacing/2)
do	nfactorial(n;nfact)
calc	betax:=beta*(x-xmiddle)
	coef:=sqrt(beta/(sqrt(PI)*2**n*nfact))
	expon:=exp(-betax*betax/2)
do	hermite(betax,n;herm)
calc	y:=coef*expon*herm
do	hermite(betax,n-1;herm)
calc	dy1:=-betax*betax*y/(x-xmiddle)+2*n*beta*coef*expon*herm
************************************************
@1pl8000unit	expon(n, plot)
@1pl4001	merge,global:
	i: n, i, plot
	f: x, y, k, A, B, numinc, dx
	f: pos, neg, kpos, kneg  $$ for recursive evaluation
	f: expkx
	f: step
	i: signofpsi, savex, savey
calc	k:=k1*sqrt(edgey(n)-E)
	x:=edgex(n-1)
	pos := expkx := exp(k*x)
	neg:=1/expkx
	A:=(k*psi+dpsi)/(2k*pos)
	B:=(k*psi-dpsi)/(2k*neg)
	pos:=A*pos
	neg:=B*neg
	step := .4/k
	numinc:=int((edgex(n)-edgex(n-1))/step)+1
	dx:=(edgex(n)-edgex(n-1))/numinc
	kpos:=exp(k*dx)
	kneg:=1/kpos
if	search & plot & n > nprob  $$ force the exponential to die away at @
+infinity
	calc	k := -dpsi/psi
		neg := exp(-k*x)
		kneg := exp(-k*dx)
		B := psi/neg
		neg := B*neg
		A := pos := kpos := 0
endif
*if	~plot
*.	calc	prob:=prob+(A*A*[exp(2k*edgex(n))-exp(2k*x)]-B*B*[exp(-2k*edge@
x(n))-exp(-2k*x)])/2k+2A*B*(edgex(n)-x)
*endif
loop	i:=1,numinc
	calc	x:=x+dx
		signofpsi := (psi > 0)
		pos:=pos*kpos
		neg:=neg*kneg
	calc	psi := pos+neg
	if	(pos+neg < 0) = signofpsi
		calc	nodes := nodes+1
	endif
	if	plot
		gdraw	;x, E+psi
		outloop	abs(psi)>100
	else
		calc	prob:=prob+psi*psi*dx
	endif
endloop
if	search & plot & n > nprob
	calc	dpsi := -k*psi
else
	calc	x:=edgex(n)
		pos:=exp(k*x)
		neg:=1/pos
		psi:=A*pos+B*neg
		dpsi:=k*A*pos-k*B*neg
endif
************************************************
@1pl8000unit	trig(n, plot)
@1pl4001	merge,global:
	f: x, y, k, C, phi, dx, numinc, i
	f: temp, sinx, cosx, sindx, cosdx  $$ for recursive evaluation
	i: n, signofpsi, plot
	f: step
calc	k:=k1*sqrt(E-edgey(n))
	x:=edgex(n-1)
	phi:=arctan(k*psi, dpsi)-k*x
	C:=sqrt(psi^2+(dpsi/k)^2)
	sinx:=C*sin(k*x+phi)
	cosx:=C*cos(k*x+phi)
	step := .4/k
	numinc:=int((edgex(n)-x)/step)+1
	dx:=(edgex(n)-x)/numinc
	sindx:=sin(k*dx)
	cosdx:=cos(k*dx)
*if	~plot
*.	calc	prob:=prob+C*C*[(edgex(n)-x)/2+(sin(2k*x+2phi)-sin(2edgex(n)+2@
phi))/4k]
*endif
loop	i:=1,numinc
	calc	x:=x+dx
		signofpsi := (sinx > 0)
		temp:=sinx*cosdx+cosx*sindx
		cosx:=cosx*cosdx-sinx*sindx
		sinx:=temp
	if	(sinx < 0) = signofpsi
		calc	nodes := nodes+1
	endif
	if	plot
		gdraw	;x, E+sinx
	else
		calc	prob:=prob+sinx*sinx*dx
	endif
endloop
calc	x:=edgex(n)
	psi:=C*sin(k*x+phi)
	dpsi:=k*C*cos(k*x+phi)
************************************************
@1pl8000unit	linear(n, plot)
@1pl4001	merge,global:
	f: x, x2, dx, initpsi
	i: signofpsi, n, plot
calc	x:=edgex(n-1)
	x2:=edgex(n)
	dx := x2-x
	initpsi:=psi
	psi:=initpsi+dpsi*dx
if	plot
	gdraw	x,E+initpsi;x2,E+psi
endif
if	(initpsi > 0) ~= (psi > 0)
	calc	nodes := nodes+1
endif
* Integrate the probability -- integral of (psi^2)dx, where psi = dpsi@
*x+initpsi
calc	prob :=[ dpsi*(dpsi*dx^2/3 + initpsi*dx) + initpsi^2]dx
************************************************
@1pl8000unit	scalewell
@1pl4001gorigin	120,100
bounds	395,250
scalex	xmax  $$ nm
scaley	Emax  $$ eV
************************************************
@1pl8000unit	getwell(;enmin,enmax)   $$ specify a well of some kind
@1pl4001	merge,global:
	f:enmin,enmax
calc	iswitch:=numchoices
if	nedges = 1
	do	getanalyticwell(;iswitch)
	erase	1,7;513,50
endif
if	iswitch = numchoices
.	do	dragwell(;enmin,enmax)
else
.	case	iswitch
.	1
.	.	do	plotsho   $$ simple harmonic oscillator
.	.	calc	enmin := -Emax
.	.		enmax := 0
.	2
.	.	do	plotfsquar(; enmin,enmax)   $$ finite square well(s)
.	3
.	.	do	plotisquar  $$ infinite square well
.	.	calc	enmin := 0
.	.		enmax := Emax
.	endcase
endif
do	showscale
************************************************
@1pl8000unit	dragwell(;enmin,enmax)
@1pl4001	merge,global:
	f:enmin,enmax
	i: i
	f: wx, wy, oldwx, oldwy
calc	enmin:=10000
	enmax:=-10000
	oldwx := edgex(nedges)
	oldwy := edgey(nedges)
text	122,9;516,75
@1pl4003Drag the mouse to define a potential well.
@1pl4001\
mode	xor
loop
.	if	nedges = 1
.	.	pause	keys=touch,back
.	else
.	.	pause	keys=back,touch(left: down,move, up)
.	endif
.	reloop	zgtouchx<edgex(nedges)
	calc	wx := zgtouchx
		wy := zgtouchy
.	if	nedges=1
.	.	calc	edgey(1) := wy
.	.	gdraw	edgex(nedges),edgey(nedges);
.	.		edgex(nedges),wy;
.	.		wx,wy
.	else
.	.	gdraw	edgex(nedges),edgey(nedges);
.	.		edgex(nedges),oldwy;
.	.		oldwx,oldwy
.	.	gdraw	edgex(nedges),edgey(nedges);
.	.		edgex(nedges),wy;
.	.		wx,wy
.	endif
.	calc	oldwx := wx
.		oldwy := wy
.	if	nedges=1 | zkey=zk(left:up)
.	.	calc	nedges := nedges+1
.	.		edgex(nedges) := wx
.	.		edgey(nedges) := wy
.	endif
.	outloop	(nedges>=20) | (edgex(nedges)>(xmax-.2))
endloop
* test well:
*set	edgex := 0, .7, 1.3, 1.8, 2.5
*set	edgey := -.7, -.7, -9.8, -6, -1
*calc	nedges := 5
mode	write
erase	122,8;513,33
calc	edgex(nedges):=xmax+.075
	enmin := 100000
	enmax := -100000
loop	i:=1,nedges
.	if	edgey(i)<enmin
.		calc	enmin:=edgey(i)
.	endif
.	if	edgey(i)>enmax
.		calc	enmax:=edgey(i)
.	endif
endloop
if	enmax>edgey(1)
.	calc	enmax:=edgey(1)
endif
if	enmax>edgey(nedges)
.	calc	enmax:=edgey(nedges)
endif
calc	nprob:=nedges+1
loop	(nprob:=nprob-1)>1
.	outloop	enmax >edgey(nprob)
endloop
************************************************
@1pl8000unit	showwell
@1pl4001	merge,global:
	f:i, x1, y1
gvector	0,.1Emax;xmax,.1Emax
calc	x1 := zwherex
	y1 := zwherey
gvector	xmax,.1Emax;0,.1Emax
text	zwherex,y1-CR;x1,y1
@1pl4003<|s,xmax|> nanometers
@1pl4001\
gvector	-.1xmax,0;-.1xmax,-Emax
gvector	-.1xmax,-Emax;-.1xmax,0
gdraw	-.13xmax,0;-.07xmax,0
gdraw	-.13xmax,-Emax;-.07xmax,-Emax
do	showscale
gat	edgex(1),edgey(1)
case	iswitch
numchoices, 2, 3
.	loop	i:=2, nedges
.	.	gdraw	; edgex(i-1),edgey(i); edgex(i),edgey(i)
.	endloop
1
.	do	plotsho2
endcase
************************************************
@1pl8000unit	showscale
@1pl4001	merge,global:
	f: Etop, Ebottom, x1, y1
erase	0,82;65,116
erase	0,330;65,367
case	iswitch
numchoices, 2	$$ mouse-drawn well or finite square well(s)
.	calc	Etop := 0
.		Ebottom := -Emax
1	$$ simple harmonic oscillator
.	calc	Etop := Emax
.		Ebottom := 0
3	$$ infinite square well
.	calc	Etop := Emax
.		Ebottom := 0
endcase
gat	-.13xmax,0
calc	x1 := zwherex-4
	y1 := zwherey
text	0,y1-CR/2;x1,y1+CR/2
@1pl4005<|s,Etop|> eV
@1pl4001\
gat	-.13xmax,-Emax
calc	x1 := zwherex-4
	y1 := zwherey
text	0,y1-CR/2;x1,y1+CR/2
@1pl4005<|s,Ebottom|> eV
@1pl4001\
************************************************
@1pl8000unit	touch(x1,y1,x2,y2;inside)
@1pl4001	f: x1,y1,x2,y2
	f: inside
calc	inside:=(x1<=ztouchx<=x2 & y1<=ztouchy<=y2)
************************************************
@1pl8000unit	eigenval1(enmin,enmax)  $$ search mouse-drawn well
@1pl4001	merge,global:
	f: enmin, enmax, dE = .001, psitest = .001, savepsi
	i: n, seeknode, godown, maxnode, savegodown
	f: stop
* This routine searches for eigenvalues by counting nodes.
* The idea is this:  There is a strict progression of one more
* node (zero-crossing) in the next higher state, with the lowest
* state having zero nodes.  We first look for the lowest state,
* then the next higher one, etc.  The trial energy is selected
* by a binary chop procedure.  We've found an eigenvalue when
* the wave function psi at +infinity is very small (or we are
* at the top of the well).  When we then plot the wave function we
* force it to go to zero at +infinity to make sure the display looks r@
ight.
*
loop	n := -1, MAXNODES
	calc	Elower(n) := enmin
		Eupper(n) := enmax
endloop
calc	E := (enmin+enmax)/2   $$ plan binary chop on energy
calc	seeknode := 0  $$ look for ground state first
	maxnode := 0  $$ none found yet
	lastenergy := E
do	markprogress(E,TRUE)
loop
	do	markprogress(lastenergy,FALSE)
	getkey
	if	zkey = zk(touch)
		do	touch(STOPX1,STOPY1,STOPX2,STOPY2;stop)
		outunit	stop
	endif
	do	markprogress(lastenergy := E,TRUE)
	do	prewave  $$ trial integration with this E; sets nodes and psi (fin@
al value of wave fct.)
	if	nodes > maxnode
		calc	maxnode := nodes  $$ max number of nodes found in a wave fct.
	endif
	if	(nodes $mask$ 1) = 0  $$ if nodes even
		calc	\ psi > 0 \ godown :=FALSE \ godown :=TRUE
	else
		calc	\ psi < 0 \ godown :=FALSE \ godown :=TRUE
	endif
	calc	savegodown := godown  $$ for debugging
		savepsi := psi
* E is upper bound on lower energy levels (those with fewer nodes)
	loop	n := nodes, 0, -1
		if	(n < nodes | godown) & Eupper(n) > E
			calc	Eupper(n) := E
		endif
	endloop
	if	~godown	$$ if going up, E is lower bound on this and upper levels
		loop	n := nodes, maxnode
			if	Elower(n) < E
				calc	Elower(n) := E
			endif
		endloop
	endif
	if	nodes > seeknode
		calc	godown := TRUE
	elseif	nodes < seeknode
		calc	godown := FALSE
	else
		if	[(enmax - Elower(seeknode) < dE) & godown] | [abs(psi) < psitest]
			do	showwave  $$ display the wave fct.
			gdraw	0,E; xmax,E
			gat	0,E
			mode	rewrite
			showt	E,3,4
			mode	write
			calc	nodes := seeknode  $$ showwave changes nodes; restore nodes
				Eupper(seeknode) := Elower(seeknode) := E
				godown := FALSE
				seeknode := seeknode + 1
		endif
	endif
	calc	\ godown \E := [E+Elower(seeknode)]/2 \ E := [E+Eupper(seeknode)@
]/2
	if	~godown & E > (enmax-dE)
		do	markprogress(lastenergy,FALSE)
		outunit
	endif
endloop
**********
@1pl8000unit	markprogress(Esearch,showit)
@1pl4001	merge,global:
	f: Esearch  $$ the energy currently being tried
	i: showit    $$ TRUE if write, FALSE if erase
mode	\showit\write\erase
gvector	xmax+.4,Esearch;xmax+.1,Esearch;10
mode	write
************************************************
@1pl8000unit	eigenval2(enmin,enmax)  $$ search harmonic or infinite --@
 known energies
@1pl4001	merge,global:
	f:enmin,enmax,enstart,index,enbase
	f: stop
if	iswitch = 3	$$ infinite square well
.	calc	enbase:=(PI/k1/iwidth)**2
.		enstart:=enbase-Emax
.		enmax := 0
elseif	iswitch = 1	$$ simple harmonic oscillator
.	calc	enstart:=.5*spacing-Emax
endif
calc	index:=0
if	enstart<enmax
.	loop
.	.	getkey
.	.	if	zkey = zk(touch)
.	.	.	do	touch(STOPX1,STOPY1,STOPX2,STOPY2;stop)
.	.	.	outloop	stop
.	.	endif
.	.	calc	index:=index+1
.	.	if	iswitch = 3	$$ infinite square well
.	.	.	calc	E:=enbase*index*index-Emax
.	.	elseif	iswitch = 1	$$ simple harmonic oscillator
.	.	.	calc	E:=(index-.5)*spacing-Emax
.	.	endif
.	outloop	E>enmax
.	.	if	iswitch = 3	$$ infinite square well
.	.	.	do	plotwave(enmin, enmax)
.	.	elseif	iswitch = 1	$$ simple harmonic oscillator
.	.	.	do	plotwave2(index-1)
.	.	endif
.	endloop
else
.	at	204,221
.	write	LOWEST EIGENVALUE IS OFF TOP OF SCREEN.
.	pause	3
.	erase	203,220;369,236
.	pause	.5
endif
calc	E:=200
************************************************
@1pl8000unit	runge(xfirst,yfirst,dy1first,energy,errmag,iswitch,stopfl@
ag,drawinc,xlast;ylast,dy1last,ymax)
@1pl4001	f:xfirst,yfirst,dy1first,energy,errmag,iswitch,xlast,ylast,dy@
1last,ymax,istepcount
	firstblock,lastblock,x(5),y(5),dy1(5),dy2(5),hstep,stepmin,errblock,i@
,iter,yold,test
	deldy15,dely5,hsprev,hsign,drawinc,xnextdraw,ydraw,stopflag
*
*  set up for plotting
*
if	drawinc ~= 0
.	inhibit	startdraw
.	gdraw	;xfirst,yfirst+energy
.	calc	xnextdraw:=xfirst+drawinc
endif
*
*  initialize
*
calc	firstblock:=TRUE
	lastblock:=FALSE
	istepcount:=4
	ymax:=abs(yfirst)
*
*  set initial conditions
*
calc	x(1):=xfirst
	y(1):=yfirst
	dy1(1):=dy1first
*
*  set initial value of d2y/dx2
*
do	sderiv(x(1),y(1),energy,iswitch;dy2(1))
*
*  set minimum step size, initial step size, and sign of step
*
calc	hstep:=abs(xlast-xfirst)/50
calc	\xlast<xfirst\hstep:=-hstep\hstep:=hstep
calc	hsign:=hstep/abs(hstep)
	stepmin:=.5
	test:=abs(xlast-xfirst)/150
calc	\stepmin>test\stepmin:=test*hsign\stepmin:=stepmin*hsign
*
*  set permissible error for first block
*
calc	errblock:=errmag* abs(hstep)
*
*  beginning of main loop
*
loop
*
*  initialize x, y, dy/dx, and d2y/dx2 for points 2 through 5 of curre@
nt block
*
.	loop	i:=2,5
.	.	calc	x(i):=x(i-1)+hstep
.	.		y(i):=y(1)+(i-1)*hstep*(dy1(1)+(i-1)*hstep*dy2(1)/2)
.	.		dy1(i):=dy1(1)+(i-1)*hstep*dy2(1)
.	.	do	sderiv(x(i),y(i),energy,iswitch;dy2(i))
.	endloop
*
*  loop through 5 iterations for current block of 4 steps, adjusting d@
y/dx and d2y/dx2 for points 2 through 5
*
.	loop	iter:=1,5
.	.	if	iter = 1 | yold = 0 | abs(dy1(5)-yold)/yold>.000025
.	.	.	calc	dy1(2):=dy1(1)+hstep/720*(251*dy2(1)+646*dy2(2)-264*dy2(3)+@
106*dy2(4)-19*dy2(5))
.	.	.		y(2):=y(1)+hstep/720*(251*dy1(1)+646*dy1(2)-264*dy1(3)+106*dy1(@
4)-19*dy1(5))
.	.	.	do	sderiv(x(2),y(2),energy,iswitch;dy2(2))
*
.	.	.	calc	dy1(3):=dy1(1)+hstep/90*(29*dy2(1)+124*dy2(2)+24*dy2(3)+4*d@
y2(4)-dy2(5))
.	.	.		y(3):=y(1)+hstep/90*(29*dy1(1)+124*dy1(2)+24*dy1(3)+4*dy1(4)-dy@
1(5))
.	.	.	do	sderiv(x(3),y(3),energy,iswitch;dy2(3))
*
.	.	.	calc	dy1(4):=dy1(1)+hstep/80*(27*dy2(1)+102*dy2(2)+72*dy2(3)+42*@
dy2(4)-3*dy2(5))
.	.	.		y(4):=y(1)+hstep/80*(27*dy1(1)+102*dy1(2)+72*dy1(3)+42*dy1(4)-3@
*dy1(5))
.	.	.	do	sderiv(x(4),y(4),energy,iswitch;dy2(4))
*
.	.	.	calc	dy1(5):=dy1(1)+4*hstep/90*(7*dy2(1)+32*dy2(2)+12*dy2(3)+32*@
dy2(4)+7*dy2(5))
.	.	.		y(5):=y(1)+4*hstep/90*(7*dy1(1)+32*dy1(2)+12*dy1(3)+32*dy1(4)+7@
*dy1(5))
.	.	.	do	sderiv(x(5),y(5),energy,iswitch;dy2(5))
.	.	endif
.	.	calc	yold:=dy1(5)
.	endloop
*
*  set maximum value of y so far
*
.	calc	\abs(y(1))>ymax\ymax:=abs(y(1))\ymax:=ymax
.	calc	\abs(y(2))>ymax\ymax:=abs(y(2))\ymax:=ymax
.	calc	\abs(y(3))>ymax\ymax:=abs(y(3))\ymax:=ymax
.	calc	\abs(y(4))>ymax\ymax:=abs(y(4))\ymax:=ymax
.	calc	\abs(y(5))>ymax\ymax:=abs(y(5))\ymax:=ymax
*
*  if derivative negative and flag set, exit
*
.	outloop	stopflag & dy1(5)<0
*
*  if last block  exit loop
*
.	outloop	lastblock
*
*  compute estimates of error
*
.	calc	deldy15:=abs(2*hstep/3*(dy2(1)-4*dy2(2)+6*dy2(3)-4*dy2(4)+dy2(5@
)))
.		dely5:=abs(2*hstep/3*(dy1(1)-4*dy1(2)+6*dy1(3)-4*dy1(4)+dy1(5)))
*
*  adjust step size and error per block
*
.	calc	hsprev:=hstep
.		hstep:=2*hstep
.	if	abs(deldy15) ~= 0
.	.	calc	test:=hsprev*(errblock/deldy15/2)**.333333
.	.	calc	\abs(hstep)>abs(test)\hstep:=test\hstep:=hstep
.	endif
.	if	dy2(5) ~= dy2(4)
.	.	calc	test:=hsprev/4/abs(dy2(5)-dy2(4))
.	.	calc	\abs(hstep)>abs(test)\hstep:=test\hstep:=hstep
.	endif
.	if	abs(dely5) ~= 0
.	.	calc	test:=hsprev*(errblock/dely5/2)**.333333
.	.	calc	\abs(hstep)>abs(test)\hstep:=test\hstep:=hstep
.	.	if	y(5) ~= 0
.	.	.	calc	test:=hsprev*(abs(y(5)/10000/dely5))**.333333
.	.	.	calc	\abs(hstep)>abs(test)\hstep:=test\hstep:=hstep
.	.	endif
.	endif
.	if	dy1(5) ~= dy1(4)
.	.	calc	test:=hsprev/4/abs(dy1(5)-dy1(4))
.	.	calc	\abs(hstep)>abs(test)\hstep:=test\hstep:=hstep
.	endif
.	calc	\abs(hstep)<stepmin\hstep:=stepmin*hsign\hstep:=hstep
.	if	(x(5)+4*hstep-xlast)*hsign>=0
.	.	calc	hstep:=(xlast-x(5))/4
.	.		lastblock:=TRUE
.	endif
.	calc	errblock:=errmag*abs(hstep)
*
*  if first block and step size too big, start over
*
.	if	firstblock
.	.	if	abs(hstep)<abs(hsprev)
.	.	.	calc	ymax:=abs(yfirst)
.	.	.	reloop
.	.	endif
.	.	calc	firstblock:=FALSE
.	endif
*
*  plot, if flag set
*
.	if	drawinc ~= 0
.	.	if	abs(y(5)) >50
outloop
.	.	elseif	 x(5)>=xnextdraw
.	.	.	gdraw 	;x(3),y(3)+energy
.	.	.	gdraw 	;x(5),y(5)+energy
.	.	.	calc	xnextdraw:=xnextdraw+drawinc
.	.	endif
.	endif
*
*  move to next block of 4 steps
*
.	calc	istepcount:=istepcount+4
.		x(1):=x(5)
.		y(1):=y(5)
.		dy1(1):=dy1(5)
.		dy2(1):=dy2(5)
*.	erase	249,219;386,300
*.	at	249,219
*.	write	hstep=<|t,hstep,3,12|>
*.		x(5)=<|t,x(5),3,12|>
*.		y(5)=<|t,y(5),3,12|>
*.		dy1(5)=<|t,dy1(5),3,12|>
*.		dy2(5)=<|t,dy2(5),3,12|>
*.	pause
*
*  end of main loop
*
endloop
*
*  plot last segment, if flag set
*
if	drawinc ~= 0
.	calc	\abs(y(5))>50\ydraw:=50*y(5)/abs(y(5))\ydraw:=y(5)
.	gdraw	;x(5),ydraw+energy
endif
*
*  set value to be returned
*
calc	ylast:=y(5)
.	dy1last:=dy1(5)
************************************************
@1pl8000unit	sderiv(x,y,energy,iswitch;dy2)
@1pl4001	merge,global:
	f:x,y,energy,dy2,V
if	iswitch=1
.	calc	V:=k1*k1*spacing*spacing/4*(x-xmiddle)**2-Emax
elseif	iswitch=4
.	calc	V:=cscfactor*(1/(cos(PI*(x-xmiddle)/iwidth))-1)-Emax
endif
calc	dy2:=y*k1*k1*(V-energy)
************************************************
@1pl8000unit	getanalyticwell(;iswit)
@1pl4001	merge,global:
	f: i,flag
	i: iswit
erase	1,7;513,50
at	248,145
write	Draw well with mouse

	Finite square well(s)
	
	Infinite square well

	Simple harmonic oscillator
loop	i:=1,4
.	box	210,145+2CR*(i-1);236,145+2CR*i-CR
endloop
loop
.	pause	keys=touch,back
.	loop	i:=1,4
.	.	do	touch(210,145+2CR*(i-1),236,145+2CR*i-CR;flag)
.	.	if	flag
.	.	.	calc	iswit:=i
outloop
.	.	endif
.	endloop
endloop
* Old listing was harmonic=1, finite=2, infinite=3, cosecant=4, draw w@
ith mouse = 5 = numchoices.
calc	\iswit-2\iswit := numchoices
	\iswit := 2
	\iswit :=3
	\iswit := 1
erase	122,103;500,340
************************************************
@1pl8000unit	plotsho  $$ simple harmonic oscillator
@1pl4001do	getspacing(1;spacing)
do	erasequest(1)
do	plotsho2
calc	edgex(1):=0
	edgex(2):=xmax
	nedges:=2
************************************************
@1pl8000unit	plotsho2
@1pl4001	merge,global:
	f:x,y
inhibit	startdraw
loop	x:=0,xmax,.05/sqrt(spacing)
.	calc	y:=k1*k1*spacing*spacing/4*(x-xmiddle)**2-Emax
.	if	y<20
.	.	gdraw	;x,y
.	endif
endloop
************************************************
@1pl8000unit	plotfsquar(; enmin, enmax)  $$ finite square well(s)
@1pl4001	merge,global:
	f:x,y,xmini,xmaxi,xloc,i,fwidth, enmin, enmax
do	getwidth(1;xmini,xmaxi)
do	getdepth(2)
do	getbarrier(3,iwidth;bnumber,bheight,bwidth)

* Canned set of parameters for testing:
*calc	iwidth := 2
*	xmini:=xmiddle-iwidth/2
*	xmaxi:=xmiddle+iwidth/2
*	bnumber := 1
*	bheight := 8
*	bwidth := .2

do	erasequest(5)
calc	nedges:=4+2*bnumber
	edgex(1):=0
	edgex(2):=xmiddle-iwidth/2
	edgex(nedges-1):=xmiddle+iwidth/2
	edgex(nedges):=xmax
	edgey(1):=edgey(2):=edgey(nedges):= -Emax+idepth
	fwidth:=(iwidth-bnumber*bwidth)/(bnumber+1)
loop	i:=3,nedges-1,2
.	calc	edgey(i):=-Emax
.		edgex(i):=xmiddle-iwidth/2+(i-1)/2*fwidth+(i-3)/2*bwidth
endloop
if	bnumber>0
.	loop	i:=4,nedges-2,2
.	.	calc	edgey(i):= -Emax+bheight
.	.		edgex(i):=edgex(i-1)+bwidth
.	endloop
endif
inhibit	startdraw
loop	i:=2, nedges
.	gdraw	; edgex(i-1),edgey(i); edgex(i),edgey(i)
endloop
calc	enmin := -Emax
	enmax := -Emax+idepth
************************************************
@1pl8000unit	plotisquar  $$ infinite square well
@1pl4001	merge,global:
	f:x,y,xmini,xmaxi,xloc
do	getwidth(1;xmini,xmaxi)
do	erasequest(1)
gdraw	xmini,10;xmini,-Emax;xmaxi,-Emax;xmaxi,10
calc	edgey(1):=edgey(4):=10
	edgey(2):=edgey(3):=-Emax
	edgex(1):=edgex(2):=xmini
	edgex(3):=xmaxi
	edgex(4):=xmax
	nedges:=4
************************************************
@1pl8000unit	getwidth(questnum;xmini,xmaxi)
@1pl4001	merge,global:
	f:xmini,xmaxi,questnum
at	QX,QY+questnum*CR
write	Enter well width in nm (0.1 to 2)  
arrow
ansv	.905,1.095
ifmatch
.	compute	iwidth
endarrow
calc	xmini:=xmiddle-iwidth/2
	xmaxi:=xmiddle+iwidth/2
************************************************
@1pl8000unit	getdepth(questnum)
@1pl4001	merge,global:
	f:questnum
at	QX,QY+questnum*CR
write	Enter well depth in eV (1 to 10)  
arrow
ansv	10.5,9.5
ifmatch
.	compute	idepth
endarrow
************************************************
@1pl8000unit	erasequest(numquest)
@1pl4001	merge,global:
	f:yloc,numquest
erase	QX,QY+CR;560,QY+CR*(numquest+1)
************************************************
@1pl8000unit	getspacing(questnum;space)
@1pl4001	merge,global:
	f:space,questnum
at	QX,QY+questnum*CR
write	Enter energy level spacing eV (2 to 10)  
arrow
ansv	6,4
ifmatch
.	compute	space
endarrow
************************************************
@1pl8000unit	getcscfactor(questnum;cscfact)
@1pl4001	merge,global:
	f:questnum,cscfact
at	QX,QY+questnum*CR
write	V(x) = A*csc(PI*x/width)+B
at	QX,QY+(questnum+1)*CR
@1pl4007write	                    Enter A (0.1 to 10)  
@1pl4001arrow
ansv	5.05,4.95
ifmatch
.	compute	cscfact
endarrow
************************************************
@1pl8000unit	getbarrier(questnum,width;bnumb,bhigh,bwide)
@1pl4001	merge,global:
	f: questnum,bhigh,bwide,maxwide,width
	i: bnumb
at	QX,QY+questnum*CR
write	Enter number of barriers (0 to 10)  
arrow
ansv	5,5
ifmatch
.	compute	bnumb
endarrow
if	bnumb = 0
	calc	maxwide:=width
		bwide := bhigh := 0
	outunit
endif
calc	maxwide:=width/bnumb
at	QX,QY+(questnum+1)*CR
write	Enter barrier width in nm (0 to <|z,maxwide,3|>)  
arrow
ansv	maxwide/2,maxwide/2
ifmatch
.	compute	bwide
endarrow
at	QX,QY+(questnum+2)*CR
write	Enter barrier height in eV (0 to 2000)  
arrow
ansv	1000,1000
ifmatch
.	compute	bhigh
endarrow
************************************************
@1pl8000unit	hermite(x,n;Hn)
@1pl4001	f:x,n,Hn,nfact,s,smax,nminus2s,nminus2sfact,sfact
calc	Hn:=0
if	n>=0
.	calc	smax:=int(n/2)
.	do	nfactorial(n;nfact)
.	loop	s:=0,smax
.	.	calc	nminus2s:=n-2*s
.	.	do	nfactorial(s;sfact)
.	.	do	nfactorial(nminus2s;nminus2sfact)
.	.	calc	Hn:=Hn+(-1)**s*(2*x)**nminus2s*nfact/nminus2sfact/sfact
.	endloop
.	if	2*int(n/2) ~= n
.	.	calc	Hn:=-Hn
.	endif
endif
************************************************
@1pl8000unit	nfactorial(n;nfact)
@1pl4001	f:n,nfact,i
calc	nfact:=1
if	n>0
.	loop	i:=1,n
.	.	calc	nfact:=nfact*i
.	endloop
endif
************************************************
@cT end
