@cT datastream 1
@4FONT
  1
3eb zsymbol
@5FONT
$syntaxlevel 2
$window	635,435

* Three-body gravitational motion; August 1997
* Bruce Sherwood
* Center for Innovation in Learning and Dept. of Physics
* Carnegie Mellon University

* This is a drastically simplified version of Orbits.t, without the ex@
tensive user interface machinery.
* It is intended to show the main features of calculating gravitationa@
l interactions among three bodies.

define	group,masses:	$$ define a group of variables to be shared among@
 several units
	float: G=1		$$ choose units so that the gravitational constant is 1
	integer: NOBJS=3	$$ number of masses
	integer: Halt	$$ TRUE if should stop plotting
	float: DT		$$ time step @1fg 3ebD@1fg8000t
	integer: DTcount	$$ number of time intervals since last dot was plott@
ed
	integer: MaxDTcount	$$ number of time intervals before plotting a dot
	integer: OFFSCREEN=1000  $$ initial position before user has specifie@
d the position

* A one-dimensional "array" defined as "Data(5)" is a set of numbers r@
eferred to as Data(1), Data(2), ... Data(5).
* A two-dimensional "array" defined as "Obj(3,7)" is a set of numbers @
referred to as Obj(1,1), Obj(1,2), ...
*      Obj(1,8), Obj(2,1), Obj(2,2), ... Obj(2,8), Obj(3,1), Obj(3,2),@
 ... Obj(3,8).
* Such a two-dimensional array is used in this program to keep track o@
f x, y, v@1fsffec@1ff  20x@1fs8000@1ff8000, v@1fsffec@1ff  20y@1fs8000@
@1ff8000,
*     mass, radius, and fixed-location nature of the object, for each @
of three masses.
* To make the body of the program easier to read and modify, symbolic @
names are given to the locations in
*     the array. For example, "R" is defined to mean "6" so that Obj(3@
,R) means Obj(3,6), the radius of object #3.

* Indices in the following "Obj" array refer to x, y, v@1fsffec@
@1ff  20x@1fs8000@1ff8000, v@1fsffec@1ff  20y@1fs8000@1ff8000, mass, r@
adius, fixed location if TRUE:
	integer: X=1, Y=2, VX=3, VY=4, M=5, R=6, COLOR=7, FIXED=8
* Define a two-dimensional array that contains 3*8 = 24 elements:
	float: Obj(NOBJS,FIXED)  $$ completely describe an object; doesn't mo@
ve if Obj(N,FIXED) is TRUE
	float: Lastxy(NOBJS,Y)     $$ save previous values of x,y for each ob@
ject
	
********************
unit	Setup
	merge,masses:	$$ "global" variables common to several units
font	zsans,15		$$ sans-serif font for execution display

calc	DT := 0.01		$$ specify time step size -- @1ff   1@1cl   2CAN CHAN@
GE THIS@1ff8000@1cl8000
	MaxDTcount := 1	$$ number of time intervals before plotting a dot -- @
@1ff   1@1cl   2CAN CHANGE THIS@1ff8000@1cl8000
jump	SetInitialConditions	$$ don't return to this Setup routine
********************
unit	SetInitialConditions	$$ set initial conditions for plotting 
	merge,masses:	$$ "global" variables common to several units
color	zblack		$$ make sure we're in standard writing color and mode
mode	write
gorigin	zxmax/2, zymax/2	   $$ establish graphing coordinates; origin @
in center of window
bounds	-100,-100; 100, 100  $$ like -axes- but doesn't actually draw t@
he axes
scalex	1		$$ choose length units so that a portion of the screen has l@
ength 1
scaley	1

at	1,1
write	Click to stop plotting

* The -set- command is convenient for initializing an array of values.@
 It is equivalent to a bunch of -calc-s.
* For example, "set  Obj := -1, 0,  0,  0, 2, 0.125, zgreen, TRUE, ...@
" has the same effect as the following calculations:
*          Obj(1,1) := -1, Obj(1,2) := 0, Obj(1,3) := 0, Obj(1,4) := 0@
, Obj(1,5) := 2, Obj(1,6) := 0.125, etc.

set	Obj := -1, 0,  0,  0, 2, 0.125, zgreen, TRUE,  $$ two fixed object@
s, one moving
	           1,0,  0,0, 1, 0.1, zmagenta, TRUE,
	           1+.004, 2, 0, 0,  0.1, 0.04, zred, FALSE
do	Plot
set	Obj := -1, 0,  0,  0, 2, 0.125, zgreen, TRUE,
	           1,0,  0,0, 1, 0.1, zmagenta, TRUE,
	           1-.004, 2, 0, 0,  0.1, 0.04, zblue, FALSE  $$ slightly dif@
ferent initial conditions make a big change
do	Plot

* Uncomment the following lines (and comment the preceding lines)
*      to see an unusual orbit with all three objects moving:
*set	Obj :=  -0.5, 0, 0.0325, 0.63, 2, 0.125, zred, FALSE, 
*	             0.5, 0, 0, -1.2, 1, 0.1, zmagenta, FALSE,
*	            0.91, 0.77, -0.65, -0.6, 0.1, 0.04, zblue, FALSE
*do	Plot

color	zblack
erase	0,0;165,20	$$ erase "Click to stop plotting"
at	zxmax/2-50,1
write	Click to start over
pause	keys=touch		$$ wait for mouse click
jump	SetInitialConditions	$$ restart the unit
********************
@1ff   1@1cl   2unit	Plot		$$ calculate and plot the motion@1ff8000@
@1cl8000
	merge,masses:
	integer: nobj
	float: time
thick	2		$$ make dots and vectors double-thick
do	ShowObjects(TRUE)	$$ show moving objects in "exclusive or" mode
calc	time := 0
	Halt := FALSE
	DTcount := 1	$$ count number of intervals before plotting a dot along@
 the trail
	
loop	nobj := 1, NOBJS	$$ take initial half step to improve accuracy
	calc	Obj(nobj,X) := Obj(nobj,X)+Obj(nobj,VX)*DT/2
		Obj(nobj,Y) := Obj(nobj,Y)+Obj(nobj,VY)*DT/2
endloop
loop	~Halt	$$ keep plotting as long as not told to halt (due to collis@
ion)
	getkey		$$ check to see whether an input has been made
	outunit	zkey = zk(touch)	$$ get out of unit if the user has clicked
	
	@1ff   1@1cl   2do	Step	$$ take one step in the numerical integration@
@1ff8000@1cl8000
	
	loop	nobj := 1, NOBJS		$$ show the new positions of the objects
		reloop	Obj(nobj,FIXED)	$$ don't bother if this object doesn't move

* In xor or "exclusive or" mode of writing, writing the same thing twi@
ce leaves the screen unchanged,
*    because a pixel's color is flipped, first one way and then anothe@
r. This leaves the background intact.
		if	MaxDTcount > 0	$$ we're plotting dots; plot disks in mode xor
			mode	xor	$$ "exclusive or" mode of writing
		else
			mode	erase	$$ plotting disks in color; erase the disk
		endif
		gatnm	Lastxy(nobj,X), Lastxy(nobj,Y)
		gdisk	Obj(nobj,R)	$$ this removes the previous disk
		mode	write		$$ restore normal writing mode
		
		if	DTcount >= MaxDTcount & MaxDTcount > 0
			color	Obj(nobj,COLOR)
			gdot	Obj(nobj,X), Obj(nobj,Y)  $$ leave a trail of dots
		endif
		
		if	MaxDTcount > 0	$$ we're plotting dots; plot disks in mode xor
			mode	xor	$$ "exclusive or" mode of writing
		else
			color	Obj(nobj,COLOR)	$$ plotting disks in color
		endif
		gatnm	Lastxy(nobj,X) := Obj(nobj,X),Lastxy(nobj,Y) := Obj(nobj,Y)
		gdisk	Obj(nobj,R)	$$ display disk in new position
	endloop
	calc	time := time+DT	$$ if interested in elapsed time
	if	DTcount >= MaxDTcount
		calc	DTcount := 1
	else
		calc	DTcount := DTcount+1	$$ increment interval count
	endif
endloop
********************
@1ff   1@1cl   2unit	Step		$$ step the velocity and position for all o@
bjects@1ff8000@1cl8000
	merge,masses:
	float: xr, yr	$$ relative x,y of attracting object
	float: temp		$$ element in determing dv@1fsffec@1ff  20x@1fs8000@
@1ff8000 and dv@1fsffec@1ff  20y@1fs8000@1ff8000
	float: rr		$$ distance between centers of  objects
	integer: n1, n2	$$ loop indices
loop	n1 := 1, NOBJS	$$ determine dv for object "n1", step the velocity
	reloop	Obj(n1,FIXED)	$$ nothing to do if object n1 is artificially fi@
xed in position
	loop	n2 := 1, NOBJS		$$ add up effects of all other masses
		reloop	n2 = n1		$$ an object doesn't act on itself
		reloop	Obj(n2,M) = 0	$$ nothing to do if object n2's mass is zero
		calc	xr := Obj(n2,X)-Obj(n1,X)	$$ relative location of other object
			yr := Obj(n2,Y)-Obj(n1,Y)
			rr := sqrt{xr^2+yr^2}	$$ center-to-center distance
		if	rr <= Obj(n1,R)+Obj(n2,R)	$$ quit if there is a collision
			calc	Halt := TRUE
			outunit
		endif
		calc	temp := G*Obj(n2,M)*DT/rr^3	$$ elements common to x and y
			Obj(n1,VX) := Obj(n1,VX)+temp*xr  $$ dv@1fsffec@1ff  20x@1fs8000@
@1ff8000 proportional to x/r@1fsffec@1ff  403@1fs8000@1ff8000
			Obj(n1,VY) := Obj(n1,VY)+temp*yr  $$ dv@1fsffec@1ff  20y@1fs8000@
@1ff8000 proportional to y/r@1fsffec@1ff  403@1fs8000@1ff8000
	endloop
endloop
loop	n1 := 1, NOBJS	$$ now step position for each object
	calc	Obj(n1,X) := Obj(n1,X)+Obj(n1,VX)*DT
		Obj(n1,Y) := Obj(n1,Y)+Obj(n1,VY)*DT
endloop
********************
unit	ShowObjects(xormode)   $$ display current positions of objects
	merge,masses:
	integer: xormode	$$ TRUE if "exclusive or" mode
	integer: nobj
loop	nobj := 1, NOBJS
	if	xormode & ~Obj(nobj,FIXED)
		mode	xor
		color	zblack
	else
		mode	write
		color	Obj(nobj,COLOR)
	endif
	gatnm	Lastxy(nobj,X) := Obj(nobj,X),Lastxy(nobj,Y) := Obj(nobj,Y)
	gdisk	Obj(nobj,R)
endloop
*********************
@cT end
