
/*
A component of the cT (TM) programming environment.
(c) Copyright 1989 Carnegie Mellon University.
cT is a trademark of Carnegie Mellon University.
All rights reserved.
May not be copied without the written consent
of Carnegie Mellon University.
*/

/* ******************************************************************* */

#include "baseenv.h"
#include "compute.h"
#include "tfiledef.h"
#include "tglobals.h"

#ifdef ctproto
int  TUTORreset_sockets(void);
int  TUTORserver(char  *addr,int  aType,char  *info);
int  TUTORsocket_server(int  fInd);
int  TUTORhosts(char  *addr,int  nn,char  *info,int  infoSize,int  *nNames);
int  TUTORsocket_client(char  *addr,int  aType,int  nn);
long  TUTORwrite_socket(int  ss,char  FAR *buf,long  len);
long  TUTORread_socket(int  ss,char  FAR *buf,long  maxLen);
int  TUTORgetchar_socket(int  ss);
int  TUTORclose_socket(struct  tutorfile FAR *tfp);
int  TUTORungetc_socket(struct  tutorfile FAR *tfp,int  cc);
#endif /* ctproto */

long TUTORread_socket();
long TUTORwrite_socket();
extern char FAR *GetPtr();
extern char FAR *TUTORalloc();

#ifdef Nosuch
/* this routine is actually defined in ctmain - for overlay reasons */
TUTORinit_sockets()
    {
    return;
    }
#endif


TUTORreset_sockets()
    {
    return(0);
    }

TUTORserver(addr,aType,info)
char *addr; /* the address we are advertising */
int aType;  /* TRUE if logical, FALSE if absolute */
char *info;  /* additional information (may by NULL) */
/* returns tutor file slot # or 0 for failure */
    {
    tfilerr = FILEMISSING;
    return(0);
    }

TUTORsocket_server(fInd)
int fInd; /* index in tutor file structure */
/* returns success flag */
    {
    return(FALSE);
    }

TUTORhosts(addr,nn,info,infoSize,nNames)
char *addr;  /* address to look up (this must be a logical type) */
int nn;  /* we want nnth instance (1 based) */
char *info;  /* to be filled with extra info */
int infoSize; /* maximum amount of info */
int *nNames; /* to be filled with # of names found */
/* returns success flag (FALSE if no names found at all) */
    {
    if (nNames)
        *nNames = 0;
    return(FALSE);
    }

TUTORsocket_client(addr,aType,nn)
char *addr;  /* address we are connecting to */
int aType; /* TRUE if logical address type */
int nn;  /* which instance (1 based) we want to connect to */
/* returns tutor file slot # or 0 for failure */
    {
    tfilerr = FILEMISSING;
    return(0);
    }

long TUTORwrite_socket(ss,buf,len)
int ss;
char FAR *buf;
long len;
/* returns # of chars actually written */
    {
    tfilerr = FILENOTOPEN;
    return(0L);
    }

long TUTORread_socket(ss,buf,maxLen)
int ss;
char FAR *buf;
long maxLen;
/* returns # of chars actually read */
    {
    tfilerr = FILENOTOPEN;
    return(0L);
    }

int TUTORgetchar_socket(ss)
int ss; /* socket to get a char from */
/* returns char or EOF */
    {
    tfilerr = FILENOTOPEN;
    return(EOF);
    }

TUTORclose_socket(tfp)
struct tutorfile FAR *tfp; /* pointer to file table entry */
    {
    return(0);
    }

int TUTORungetc_socket(tfp,cc)
struct tutorfile FAR *tfp; /* pointer to file table entry */
int cc;

{
    return(0);
}

